unit Editor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Menus,utils, mwCustomEdit, mwHighlighter, mwPasSyn;

type
  TWrAction= (wrInsert, wrDelete, wrRename);

  TEditorForm = class(TForm)
    StatusBar: TStatusBar;
    PageControl1: TPageControl;
    OpenDialog1: TOpenDialog;
    MsgViewPopupMenu: TPopupMenu;
    mvViewSourceItem: TMenuItem;
    mvAltViewSourceItem: TMenuItem;
    mvEditSourceItem: TMenuItem;
    mvAltEditSourceItem: TMenuItem;
    N3: TMenuItem;
    ClearCompilerMessagesItem: TMenuItem;
    ClearSearchResultsItem: TMenuItem;
    EditorLocalMenu: TPopupMenu;
    ecClosePage: TMenuItem;
    ecOpenFileAtCursor: TMenuItem;
    ecNewEditWindow: TMenuItem;
    ecBrowseSymbolAtCursor: TMenuItem;
    ecTopicSearch: TMenuItem;
    ecAddtoInterface: TMenuItem;
    ecToggleBreakpoint: TMenuItem;
    ecGotoCursor: TMenuItem;
    ecEvaluateModify: TMenuItem;
    ecAddWatchAtCursor: TMenuItem;
    MenuItem1: TMenuItem;
    ecViewAsFormItem: TMenuItem;
    ecReadOnlyItem: TMenuItem;
    ecMessageView: TMenuItem;
    MenuItem2: TMenuItem;
    ecPropertiesItem: TMenuItem;
    SmallGutterImages: TImageList;
    LargeGutterImages: TImageList;
    mwPasSyn1: TmwPasSyn;
    N1: TMenuItem;
    ToggleBookmakrs1: TMenuItem;
    GotoBookamrks1: TMenuItem;
    Bookamrk01: TMenuItem;
    Bookmark11: TMenuItem;
    Bookmark21: TMenuItem;
    Bookmark31: TMenuItem;
    Bookmark41: TMenuItem;
    Bookmark51: TMenuItem;
    Bookmark61: TMenuItem;
    Bookmark71: TMenuItem;
    Bookmark81: TMenuItem;
    Bookmark91: TMenuItem;
    Bookmark01: TMenuItem;
    Bookmark12: TMenuItem;
    Bookmark22: TMenuItem;
    Bookmark32: TMenuItem;
    Bookmark42: TMenuItem;
    Bookmark52: TMenuItem;
    Bookmark62: TMenuItem;
    Bookmark72: TMenuItem;
    Bookmark82: TMenuItem;
    Bookmark92: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PageControl1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ecClosePageClick(Sender: TObject);
    procedure ecOpenFileAtCursorClick(Sender: TObject);
    procedure ecReadOnlyItemClick(Sender: TObject);
    procedure PasEditorKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PasEditorChange(Sender: TObject);
    procedure Bookamrk01Click(Sender: TObject);
    procedure Bookmark01Click(Sender: TObject);
    procedure ecTopicSearchClick(Sender: TObject);
  private
    { Private declarations }
    function GetStringPos(const S:string):Integer;
    procedure ProcessKeyDown(var Key: Word; Shift: TShiftState);
    procedure CaretInfo;
  protected
    procedure OnGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
  public
    { Public declarations }
     procedure WriteComponentCode(Component:string;ComponentClass:
               TComponentClass;Action:TWrAction);
     procedure WriteEventCode(Event:string);
     procedure GotoLine(PasEdit:TmwCustomEdit;Line:Integer);
     function  GetLinkEditor:TmwCustomEdit;
     function  MoveToString(const FindStr:string):Boolean;
     procedure RenameUnit(UnitName:string);
     procedure NewSheet(const FileName:string);
     function  GetCursorWord:string;
  end;

var
  EditorForm: TEditorForm;

implementation

uses MainForm,Uconst, utype;

var
   Insert:boolean;

{$R *.DFM}

procedure TEditorForm.OnGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
// Editor  ִȭ ,  ũ⸦    Ѵ.
begin
    inherited;
    msg.MinMaxInfo^.ptMaxPosition.y := Top;
    msg.MinMaxInfo^.ptMaxTrackSize.x := Screen.Width;
    msg.MinMaxInfo^.ptMaxTrackSize.y := Screen.Height -  Top;
end;

procedure TEditorForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
   I,SaveResp:integer;
   FileName:string;
begin
    for I := PageControl1.PageCount-1 downto 0 do begin
      FileName:=(PageControl1.Pages[I]).Caption;
      if (PageControl1.Pages[I].Controls[0] as TmwCustomEdit).Modified then begin
          SaveResp := MessageDlg(Format('Save Changes to %s?',
             [ExtractFilename(FileName)]), mtWarning, mbYesNoCancel, 0);
          case SaveResp of
             idYes: FMainForm.SaveFile(ProjectPath+Caption);
             idNo: ;
             idCancel: Abort;
          end;
      end;
    end;
end;

procedure TEditorForm.PageControl1Change(Sender: TObject);
begin
    //  ŸƲ  ϰ ִ ϸ ش.
    if ExtractFileExt(PageControl1.ActivePage.Caption)= '' then
    // ϰ ִ  Ʈ ̸ pas Ȯڸ ߰Ѵ.
       Caption:=PageControl1.ActivePage.Caption+'.pas'
    else Caption:=PageControl1.ActivePage.Caption;
    FMainForm.ActiveUnit:=
         FMainForm.OpenUnitList[PageControl1.ActivePage.Controls[0].Tag].FileName;
    ActivePasEditor:= TmwCustomEdit(PageControl1.ActivePage.Controls[0]);
end;

procedure TEditorForm.WriteComponentCode(Component:string;ComponentClass:
          TComponentClass;Action:TWrAction);
const
   ClassName= 'TForm';
var
   InsertPos: Integer;
   PasEdit: TmwCustomEdit;
// ۳Ʈ ߰ ,  ,ϴ ش ڵ带 ۼ Ǵ ,Ѵ.
begin
   PasEdit:=GetLinkEditor;
   if Action=wrInsert then
      InsertPos:=GetStringPos(ClassName)  // ڵ带 ؾ   Ѵ.
   else
      InsertPos:=GetStringPos(Component);
   if InsertPos=0 then Exit;
   case Action of
      wrInsert:  // ڵ带 ۼϴ 
      begin
          PasEdit.Lines.Insert(InsertPos+1,'    '+Component+':'+ComponentClass.ClassName+';');
      end;
      wrDelete:  // ڵ带 ϴ 
          PasEdit.Lines.Delete(InsertPos);
   end;
end;

function TEditorForm.GetStringPos(const S:string):Integer;
// ҽ ڵ忡 Ư ڿ S ִ  ġ ˷ش.
var
   I: Integer;
   PasEdit: TmwCustomEdit;
begin
    Result:=0;
    PasEdit:=GetLinkEditor;
    with PasEdit do begin
       for I:=0 to Lines.Count-1 do
          if Pos(S,Lines[I])>0 then begin
             Result:=I;
             Exit;
          end;
    end;
end;

// ̺Ʈ ̸ Event  ⺻ ڵ带 ۼѴ.
procedure TEditorForm.WriteEventCode(Event:string);
var
   PasEdit: TmwCustomEdit;
begin
    PasEdit:=GetLinkEditor;
    with PasEdit.Lines do begin
       Insert(Count-2,'');
       Insert(Count-2,'procedure '+'T'+Name+'.'+Event);
       Insert(Count-2,'begin');
       Insert(Count-2,'');
       Insert(Count-2,'end;');
    end;
    PasEdit.SetFocus;
    GotoLine(PasEdit,PasEdit.Lines.Count-3);
end;

procedure TEditorForm.GotoLine(PasEdit:TmwCustomEdit;Line:Integer);
var
   NewLine,LinePos,CurLine:integer;
begin
    // Ư  ȣ ̵Ѵ.
  //// PasEdit.SelStart :=SendMessage(PasEdit.handle, EM_LINEINDEX, Line, 0) - 1;
end;

function TEditorForm.GetLinkEditor:TmwCustomEdit;
var
   I:Integer;
   FileName:string;
begin
   //   Ʈ  Edit ã´.
   Result:=TmwCustomEdit(PageControl1.ActivePage.Controls[0]);
   for I:=0 to PageControl1.PageCount-1 do
   begin
      FileName:= ExtractFileName(FMainForm.ActiveUnit);
      if TTabSheet(PageControl1.Pages[I]).Caption = FileName then
         Result:= TmwCustomEdit(PageControl1.Pages[I].Controls[0]);
   end;
end;

function TEditorForm.MoveToString(const FindStr:string):Boolean;
// ҽ ڵ忡 ڿ FindStr ã  ش  ̵Ѵ.
var
   PasEdit: TmwCustomEdit;
   FindPos:Integer;
begin
    Result:=True;
    PasEdit:=GetLinkEditor;
    FindPos:=GetStringPos(FindStr);
    PasEdit.SetFocus;
    GotoLine(PasEdit,FindPos+3);
end;

procedure TEditorForm.RenameUnit(UnitName:string);
// unit ̸ UnitName ٲ۴.
var
  PasEdit:TmwCustomEdit;
  Name:string;
begin
   PasEdit:= GetLinkEditor;
   Name:= PasEdit.Lines[0];
   if Pos('unit', Name) > 0 then
      PasEdit.Lines[0]:= Format('%s %s;',['unit',GetNetFileName(UnitName)]);
end;

procedure TEditorForm.FormActivate(Sender: TObject);
begin
   FMainForm.ToggleFormUnit:= False;
end;

procedure TEditorForm.ProcessKeyDown(var Key: Word; Shift: TShiftState);
var
   LinePos:integer;
begin
   CaretInfo;
   if (Key=VK_INSERT)  then  begin
      Insert:=not Insert;
      if Insert then   StatusBar.Panels[1].Text:='Insert'
      else StatusBar.Panels[1].Text:='Modified';
   end
   else if (Key = VK_F1) then ShowKeywordHelp(GetCursorWord);
end;

procedure TEditorForm.NewSheet(const FileName:string);
//  Ʈ  ִ ͸ Ѵ.
var
   PasEdit:TmwCustomEdit;
   TabSheet:TTabSheet;
   List:TStringList;
begin
   TabSheet:=TTabSheet.Create(PageControl1);
   with TabSheet do
   begin
      PageControl := PageControl1;
      if ExtractFileExt(FileName)='.pas' then Caption:=GetNetFileName(FileName)
      else Caption:=ExtractFileName(FileName);
      PasEdit:= TmwCustomEdit.Create(PageControl1);
      PasEdit.Parent := TabSheet;
     // RichEdit.Name := UniqueName(RichEdit);
      PasEdit.Color:= IniFile.ReadInteger('EDITOR','BackColor',clWhite);
      PasEdit.Font.Name:= IniFile.ReadString('EDITOR','FONTNAME','Arial');
      PasEdit.Font.Size:= IniFile.ReadInteger('EDITOR','FONTSIZE',10);
      PasEdit.Align:=alClient;
     //// RichEdit.PlainText:= not IniFile.ReadBool('EDITOR','HighLight',False);
      PasEdit.PopupMenu:= EditorLocalMenu;
      PasEdit.ScrollBars:=ssBoth;
      PasEdit.HighLighter:= mwPasSyn1;
      PasEdit.OnKeyUp:= PasEditorKeyUp;
      PasEdit.OnChange:= PasEditorChange;
   end;
   Caption:=FileName;
   PageControl1.ActivePage:=TabSheet;
   Show;
   ActivePasEditor:= PasEdit;
end;

procedure TEditorForm.ecClosePageClick(Sender: TObject);
begin
    FMainForm.CloseActiveFile;
end;

procedure TEditorForm.ecOpenFileAtCursorClick(Sender: TObject);
var
   List:TStringList;
   I:Integer;
begin
    if OpenDialog1.Execute then
    begin
       List:=TStringList.Create;
       List.LoadFromFile(OpenDialog1.FileName);
       for I:=0 to List.Count-1 do
           ActivePasEditor.Lines.Insert(1,List[I]);
    end;
end;

procedure TEditorForm.ecReadOnlyItemClick(Sender: TObject);
begin
    ecReadOnlyItem.Checked:=not ecReadOnlyItem.Checked;
    ActivePasEditor.ReadOnly:= ecReadOnlyItem.Checked;
    if ecReadOnlyItem.Checked then   StatusBar.Panels[1].Text:='ReadOnly'
    else StatusBar.Panels[1].Text:='';
end;

// Ŀ ġ ִ ܾ ˷ش.
function TEditorForm.GetCursorWord:string;
var
  WordText:string;
  I,LineLength,LinePos:Integer;
  CurPos,StartPos,EndPos:Integer;
begin
  Result:='';
  WordText:= ActivePasEditor.LineText;  // Ŀ ġ ִ  ڿ
  if Length(WordText)<1 then Exit;
  CurPos:=ActivePasEditor.CaretX;
  LineLength:= Length(WordText);
  for I:= CurPos downto 1 do begin
      if (WordText[I] ='')  then Exit;
      if WordText[I] in [' ',#0..#47,#58..#64,#91..#96,#123..#127] then Break;
  end;
  StartPos:= I+1;  // ܾ  ġ
  for I:= CurPos to LineLength do begin
      if WordText[I] ='' then Exit;
      if WordText[I] in [' ',#0..#47,#58..#64,#91..#96,#123..#127] then Break;
  end;
  EndPos:= I;  // ܾ  ġ
  WordText:= Trim(Copy(WordText,StartPos, EndPos-StartPos));
  Result:= WordText;
end;

procedure TEditorForm.PasEditorKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   ProcessKeyDown(Key,Shift);
end;

// Ϳ  ߻  Ʈ ¿ ư  θ Ѵ.
procedure TEditorForm.PasEditorChange(Sender: TObject);
begin
    CaretInfo;
    // Ʈ ó д 쿡 ȭ Ѵ.
    if not TmwCustomEdit(Sender).Modified then Exit;
    StatusBar.Panels[2].Text:='Modified';
    ProjectInfo.ProjectState:=psChange;
    FMainForm.sbSaveAll.Enabled:=True;
end;

procedure TEditorForm.CaretInfo;
var
   Col,Row:integer;
begin
   // ĳ ġ Ѵ.
   Col:= ActivePasEditor.CaretX;
   Row:= ActivePasEditor.CaretY;
   StatusBar.Panels[0].Text:=IntToStr(Row)+' :' + IntToStr(Col);
end;

procedure TEditorForm.Bookamrk01Click(Sender: TObject);
// Set BookMark 
var
   BookMark, X, Y: integer;
   PasEdit: TmwCustomEdit;
begin
   (Sender as TMenuItem).Checked:= not (Sender as TMenuItem).Checked;
   if (Sender as TMenuItem).Checked then
   begin
      PasEdit:=  ActivePasEditor;
      BookMark:= (Sender as TMenuItem).Tag;
      X:= PasEdit.CaretX;
      Y:= PasEdit.CaretY;
      PasEdit.SetBookMark(BookMark, X, Y);
   end
   else ActivePasEditor.ClearBookMark((Sender as TMenuItem).Tag);
end;

procedure TEditorForm.Bookmark01Click(Sender: TObject);
begin
    ActivePasEditor.GotoBookMark((Sender as TMenuItem).Tag);
end;

procedure TEditorForm.ecTopicSearchClick(Sender: TObject);
begin
   ShowKeywordHelp(GetCursorWord);
end;

end.


