unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus,ToolIntf, Buttons, ComCtrls, ExtCtrls, StdCtrls,utype, TypInfo,Proxies
  , Mask,FileCtrl, Grids, MPlayer, Gauges,uconst,
  Calendar, Outline, DirOutln, Spin, ColorGrd, extdlgs,clipbrd,checklst,olectnrs,ddeman,
  Tabs, Tabnotbk, mwCustomEdit
  {$DEFINE DBVERSION}
  {$IFDEF DBVERSION}
    ,DB, DBTables,DBGrids, DBCtrls, DBCGrids,quickrpt, Qrctrls,  qrprntr,DBLookup
  {$ENDIF};

type
  TYB_FindScope = (fsGlobal, fsSelected);
  TYB_FindOrigin = (foCursor, foEntire);
  TYB_FindDirection = (fdDown, fdUp);
  TYB_SearchType = record
    FindOption:TSearchTypes;
    Direction:TYB_FindDirection;
    Scope: TYB_FindScope;
    Origin: TYB_FindOrigin;
    ReplaceAll:Boolean;
    PromptOn:Boolean;
  end;

  TOpenUnitList = record
     FileName:string;
     Modified:Boolean;
     Closed:Boolean;
  end;

  TFMainForm = class(TForm)
    MainMenu1: TMainMenu;
    FileMenu: TMenuItem;
    FileNewItem: TMenuItem;
    FileNewApplicationItem: TMenuItem;
    FileNewFormItem: TMenuItem;
    FileNewDataModuleItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileReOpenItem: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    EditMenu: TMenuItem;
    SearchMenu: TMenuItem;
    ViewMenu: TMenuItem;
    ProjectMenu: TMenuItem;
    RunMenu: TMenuItem;
    ComponentMenu: TMenuItem;
    DatabaseMenu: TMenuItem;
    ToolsMenu: TMenuItem;
    HelpMenu: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FileSaveProjectAsItem: TMenuItem;
    FileSaveAllItem: TMenuItem;
    FileCloseItem: TMenuItem;
    FileCloseAllItem: TMenuItem;
    FileUseUnitItem: TMenuItem;
    FileAddItem: TMenuItem;
    FileRemoveItem: TMenuItem;
    FilePrintItem: TMenuItem;
    FileExitItem: TMenuItem;
    EditUndoItem: TMenuItem;
    EditRedoItem: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    EditDeleteItem: TMenuItem;
    EditSelectAllItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    SearchFindItem: TMenuItem;
    SearchFindInFilesItem: TMenuItem;
    SearchReplaceItem: TMenuItem;
    SearchAgainItem: TMenuItem;
    SearchIncrementalItem: TMenuItem;
    SearchGotoItem: TMenuItem;
    SearchBrowseSymbolItem: TMenuItem;
    ViewProjectManagerItem: TMenuItem;
    ViewProjectSourceItem: TMenuItem;
    ViewObjectInspectorItem: TMenuItem;
    ViewAlignItem: TMenuItem;
    ViewBrowseItem: TMenuItem;
    ViewComponentListItem: TMenuItem;
    ViewWindowListItem: TMenuItem;
    ViewToggleFormItem: TMenuItem;
    ViewUnitItem: TMenuItem;
    ViewFormItem: TMenuItem;
    ViewNewEditorItem: TMenuItem;
    ViewSpeedBarItem: TMenuItem;
    ViewPaletteItem: TMenuItem;
    ProjectAddItem: TMenuItem;
    ProjectRemoveItem: TMenuItem;
    ProjectAddRepositoryItem: TMenuItem;
    ProjectCompileItem: TMenuItem;
    ProjectBuildAllItem: TMenuItem;
    ProjectSyntaxItem: TMenuItem;
    ProjectInformationItem: TMenuItem;
    ProjectOptionsItem: TMenuItem;
    RunRunItem: TMenuItem;
    RunParametersItem: TMenuItem;
    RunStepoverItem: TMenuItem;
    RunTraceintoItem: TMenuItem;
    RunRuntocursorItem: TMenuItem;
    RunProgramPauseItem: TMenuItem;
    RunProgramResetItem: TMenuItem;
    RunAddWatchItem: TMenuItem;
    RunAddBreakpointItem: TMenuItem;
    RunEvaluateItem: TMenuItem;
    ComponentNewComponentItem: TMenuItem;
    ComponentInstallComponent: TMenuItem;
    ComponentInstallPackages: TMenuItem;
    ComponentConfigurePalette: TMenuItem;
    DatabaseExploreItem: TMenuItem;
    DatabaseFormWizardItem: TMenuItem;
    ToolsOptionsItem: TMenuItem;
    ToolsGalleryItem: TMenuItem;
    ToolsToolsItem: TMenuItem;
    ToolsImageEditItem: TMenuItem;
    ToolsDatabaseItem: TMenuItem;
    SaveDialog1: TSaveDialog;
    N11: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    N24: TMenuItem;
    N25: TMenuItem;
    EditAlignGridItem: TMenuItem;
    EditFrontItem: TMenuItem;
    EditBackItem: TMenuItem;
    EditAlignItem: TMenuItem;
    EditSizeItem: TMenuItem;
    EditScaleItem: TMenuItem;
    EditTabOrderItem: TMenuItem;
    EditCreateOrderItem: TMenuItem;
    N82: TMenuItem;
    N83: TMenuItem;
    N84: TMenuItem;
    N85: TMenuItem;
    N86: TMenuItem;
    N87: TMenuItem;
    N88: TMenuItem;
    N89: TMenuItem;
    N90: TMenuItem;
    SpeedBar: TPanel;
    sbOpenProject: TSpeedButton;
    sbSaveAll: TSpeedButton;
    sbAddProject: TSpeedButton;
    sbUnits: TSpeedButton;
    sbForms: TSpeedButton;
    sbRun: TSpeedButton;
    sbPause: TSpeedButton;
    sbOpenFile: TSpeedButton;
    sbSave: TSpeedButton;
    sbRemoveProject: TSpeedButton;
    sbToggleUnit: TSpeedButton;
    sbNewForm: TSpeedButton;
    sbTraceInto: TSpeedButton;
    sbStepOver: TSpeedButton;
    N22: TMenuItem;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    PopupMenu1: TPopupMenu;
    ShowSpeedbarHint: TMenuItem;
    NHide: TMenuItem;
    SpeedbarHelpItem: TMenuItem;
    Configure1: TMenuItem;
    N33: TMenuItem;
    HelpContextItem: TMenuItem;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    PaletteMenu: TPopupMenu;
    ShowPaletteHints: TMenuItem;
    Hide2: TMenuItem;
    PaletteHelpItem: TMenuItem;
    N9: TMenuItem;
    Configure2: TMenuItem;
    Breakpoints1: TMenuItem;
    Modules1: TMenuItem;
    HandelHelp1: TMenuItem;
    Compileactivefile1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure sbButtonClick(Sender: TObject);
    procedure sbOpenFileClick(Sender: TObject);
    procedure sbFormsClick(Sender: TObject);
    procedure sbUnitsClick(Sender: TObject);
    procedure ViewProjectSourceItemClick(Sender: TObject);
    procedure sbOpenProjectClick(Sender: TObject);
    procedure ViewProjectManagerItemClick(Sender: TObject);
    procedure ProjectCompileItemClick(Sender: TObject);
    procedure ProjectBuildAllItemClick(Sender: TObject);
    procedure RunRunItemClick(Sender: TObject);
    procedure sbMainMenuClick(Sender: TObject);
    procedure EditCopyItemClick(Sender: TObject);
    procedure EditPasteItemClick(Sender: TObject);
    procedure EditCutItemClick(Sender: TObject);
    procedure FileSaveItemClick(Sender: TObject);
    procedure FilePrintItemClick(Sender: TObject);
    procedure EditSelectAllItemClick(Sender: TObject);
    procedure EditUndoItemClick(Sender: TObject);
    procedure SearchGotoItemClick(Sender: TObject);
    procedure ViewObjectInspectorItemClick(Sender: TObject);
    procedure ViewNewEditorItemClick(Sender: TObject);
    procedure ViewSpeedBarItemClick(Sender: TObject);
    procedure ViewPaletteItemClick(Sender: TObject);
    procedure FileNewFormItemClick(Sender: TObject);
    procedure SearchFindItemClick(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure SearchReplaceItemClick(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure FileNewApplicationItemClick(Sender: TObject);
    procedure FileCloseAllItemClick(Sender: TObject);
    procedure sbSaveAllClick(Sender: TObject);
    procedure sbToggleUnitClick(Sender: TObject);
    procedure NHideClick(Sender: TObject);
    procedure ToolsOptionsItemClick(Sender: TObject);
    procedure ToolsImageEditItemClick(Sender: TObject);
    procedure ToolsDatabaseItemClick(Sender: TObject);
    procedure ProjectOptionsItemClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ProjectAddItemClick(Sender: TObject);
    procedure ProjectRemoveItemClick(Sender: TObject);
    procedure ViewWindowListItemClick(Sender: TObject);
    procedure ViewComponentListItemClick(Sender: TObject);
    procedure ToolsToolsItemClick(Sender: TObject);
    procedure SearchFindInFilesItemClick(Sender: TObject);
    procedure FileSaveAsItemClick(Sender: TObject);
    procedure FileSaveAllItemClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure EditFrontItemClick(Sender: TObject);
    procedure EditBackItemClick(Sender: TObject);
    procedure EditAlignItemClick(Sender: TObject);
    procedure EditSizeItemClick(Sender: TObject);
    procedure HelpContextItemClick(Sender: TObject);
    procedure EditScaleItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileSaveProjectAsItemClick(Sender: TObject);
    procedure ComponentNewComponentItemClick(Sender: TObject);
    procedure ViewAlignItemClick(Sender: TObject);
    procedure Breakpoints1Click(Sender: TObject);
    procedure ViewBrowseItemClick(Sender: TObject);
    procedure EditCreateOrderItemClick(Sender: TObject);
    procedure RunEvaluateItemClick(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
    procedure Modules1Click(Sender: TObject);
    procedure ToolsGalleryItemClick(Sender: TObject);
    procedure RunParametersItemClick(Sender: TObject);
    procedure EditTabOrderItemClick(Sender: TObject);
    procedure RunAddWatchItemClick(Sender: TObject);
    procedure ComponentConfigurePaletteClick(Sender: TObject);
    procedure FileNewDataModuleItemClick(Sender: TObject);
    procedure FileUseUnitItemClick(Sender: TObject);
    procedure EditRedoItemClick(Sender: TObject);
    procedure EditDeleteItemClick(Sender: TObject);
    procedure EditAlignGridItemClick(Sender: TObject);
    procedure SearchIncrementalItemClick(Sender: TObject);
    procedure SearchBrowseSymbolItemClick(Sender: TObject);
    procedure ProjectAddRepositoryItemClick(Sender: TObject);
    procedure ProjectSyntaxItemClick(Sender: TObject);
    procedure ProjectInformationItemClick(Sender: TObject);
    procedure RunStepoverItemClick(Sender: TObject);
    procedure RunTraceintoItemClick(Sender: TObject);
    procedure RunRuntocursorItemClick(Sender: TObject);
    procedure RunProgramPauseItemClick(Sender: TObject);
    procedure RunProgramResetItemClick(Sender: TObject);
    procedure RunAddBreakpointItemClick(Sender: TObject);
    procedure ComponentInstallComponentClick(Sender: TObject);
    procedure ComponentInstallPackagesClick(Sender: TObject);
    procedure Configure2Click(Sender: TObject);
    procedure Hide2Click(Sender: TObject);
    procedure ShowSpeedbarHintClick(Sender: TObject);
    procedure ShowPaletteHintsClick(Sender: TObject);
    procedure SpeedbarHelpItemClick(Sender: TObject);
    procedure PaletteHelpItemClick(Sender: TObject);
    procedure Configure1Click(Sender: TObject);
    procedure HandelHelp1Click(Sender: TObject);
    procedure Compileactivefile1Click(Sender: TObject);
  private
    { Private declarations }
    ParseLine:Integer;
    SourceList: TStringList;  //   ؽƮ ǥ Ѵ.
    fShiftKeyed:Boolean;
    function  CompileAndInformation(const Option:string):Boolean;
    function  CreateForm(const FormName,UnitName:string):TForm;  // Ͻ  Ѵ.
    function  SaveProject(const ProjName:string):Boolean;
    function  OpenProject(const ProjName:string):Boolean;
    procedure OpenForm(const FileName:string);
    procedure SaveForm(Form:TForm;FormName:string);
    procedure NewProject;
    procedure ProxyFormShow(Sender: TObject);
    function  UniqueName(Comp:TComponent):string;
    function  TryName(const Test:string;Comp:TComponent):Boolean;
    function  GetUnitName(const FormName:string):string;
    procedure SaveProjectHistory(const Project:string);
    procedure SaveFileHistory(const Filename:string);
    procedure OpenHistory;
    procedure OpenHistoryFile(Sender: TObject);
    procedure ExecuteTool(Sender: TObject);
    function  SearchingText(SearchStr:string;Options:TYB_SearchType):Boolean;
    procedure ReplacingText(FindText,ReplaceText:string;Options:TYB_SearchType);
    procedure LoadLanguageRes;
    procedure FileSaveAs(Filename:string);
    function  Compile(const ProjName, Option:string):Boolean;
    procedure MakeBitmap(Component:TSpeedButton;ComponentName:string);
    procedure CreatePalettePage(PalettePage:string);
    procedure LoadingComponents;
    procedure LoadDefaultPalette;
    procedure LoadDefaultButton(TabSheet:TTabSheet);
    procedure CreateSheet(const FileName:string);
    procedure CreateSheetAsStream(const FileName:string;Stream:TStream);
    procedure FileNewDataModuleClick;
    procedure FileUseUnit;
    procedure EditRedo;
    procedure EditDelete;
    procedure EditAlignToGrid;
    procedure SearchIncrementalClick;
    procedure SearchSymbol;
    procedure ProjectAddRepository;
    procedure ProjectSyntaxCheck;
    procedure ProjectInformation;
    procedure RunStepOver;
    procedure RunStepInto;
    procedure RunGotoCursor;
    procedure RunPause;
    procedure ProgramReset;
    procedure RunAddBreakpoint;
    procedure AddtoPackage1Click;
    procedure InstallPackagesClick;
    procedure ProcessShowHint(var HintStr: string; var CanShow: Boolean;
              var HintInfo: THintInfo);
    function  IsOpenedFile(const FileName:string):Integer;
 protected
    procedure OnGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
 public
    { Public declarations }
    ToggleFormUnit:Boolean;
    UnitCount:Integer;                            // ̶   
    ActiveUnit: string;                           //  ۾ϰ ִ Ʈ ̸
    ActiveForm:TForm;                             //  ۾ϰ ִ 
    SelectedComponent:TComponent;
    OpenUnitList: array [1..255] of TOpenUnitList;  // ۾ Ʈ  
    procedure ReadClass;
    procedure OpenFile(const FileName:string);
    procedure SaveFile(const FileName:string);
    function  GetSelectComponent:TComponentClass;
    function  GetLinkForm:TForm;
    function  GetLinkUnit(FormName:string):string;
    procedure ToggleFormAndUnit;
    procedure OpenTools;
    procedure OpenFormAsText(const FileName:string);
    procedure UpdateControl(State:TProjectState);
    procedure CloseActiveFile;
    property  ShiftKeyed:Boolean read fShiftKeyed write fShiftKeyed;
  end;

var
  FMainForm: TFMainForm;
  SearchOption:TYB_SearchType;

implementation

uses ObjectInspec, Proxy, About, Editor, uviewform, UProject, utils,
  UOptions, UProOption, ucreateform, ShellAPI,IniFiles,
  URemoveUnit, UWindowList, UComponentList, Utools, ucompile, USearch,RichEdit,
  UFindInFile, UReplace,resource, uAlignDialog, uSizeDialog, Uscale,
  UNewcomp, UAlignPal, BPWindow, UBrowser, UCreateOrderDlg, UEvaDialog,
  UGalleryBrowseDlg, UModulesView, UPrintSelDlg, URepositConfigDlg,
  URunParamsDlg, UTabOrderDlg, UWatchEditDlg, SBEditor, UInstallComp,
  DFMUtils;

var
   EndPos,OldLine,MatchPos:integer;
   SearchText:string;

{$R *.DFM}

procedure TFMainForm.OnGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
// Thanks to Dillan2@mail.hitel.net
var
    r : TRect;
    style : Longint;
begin
    inherited;
    r := SpeedBar.BoundsRect;
    style := GetWindowLong(Self.Handle, GWL_STYLE);
    AdjustWindowRect(r, style, TRUE);
    msg.MinMaxInfo^.ptMaxTrackSize.x := Screen.Width;
    msg.MinMaxInfo^.ptMaxTrackSize.y := r.bottom - r.top;
end;

procedure TFMainForm.FormCreate(Sender: TObject);
var
  Delphi:string;
begin
    // Ʈ ȯ ʱȭѴ.
    Left:=0;
    Top:=0;
    UnitCount:= 1;
    OpenUnitList[1].FileName:= 'unit1.pas';
    ToggleFormUnit:=False;
    SourceList:= TStringList.Create;
    ProjectInfo:=TProjectInfo.Create(self);
    GetDir(0,TempDir);
    TempDir:= AppendSlash(TempDir);
    FilePath:=ExtractFilePath(Application.ExeName);
    IniFile:=TIniFile.Create(FilePath+IniName);
    LoadingComponents;
    Delphi:= AppendSlash(IniFile.ReadString('SYSTEM','DELPHI',''));
    CompilerPath:= Delphi + 'bin\';
    if IniFile.ReadBool('SYSTEM','DefaultCompiler',True) then
       CompilerName:= CompilerPath+'DCC32.exe'
    else CompilerName:= Trim(IniFile.ReadString('Compiler','FPC', ''));
    Desktop:=IniFile.ReadString('SYSTEM','DESKTOP','');
    Application.HelpFile:= Delphi + 'help\delphi3.hlp';
    Application.OnShowHint:= ProcessShowHint;
    //LoadLanguageRes;
    OpenHistory;
    OpenTools;
end;

procedure TFMainForm.FileExitItemClick(Sender: TObject);
begin
   Close;
end;

procedure TFMainForm.FormShow(Sender: TObject);
var
   I:Integer;
   FileName:string;
begin
    ObjectInspector.Show;
    EditorForm.Show;
    NewProject;
    { μ ִ  , ش  ҷ´.}
    if ParamCount>0 then begin
       for I:=1 to ParamCount do
           FileName:=FileName+' '+ParamStr(I);
       if FileExists(ParamStr(1)) then begin
          OpenFile(ParamStr(1));
       end
       else begin
          OpenFile(Trim(FileName));
       end;
    end;
end;

procedure TFMainForm.HelpAboutItemClick(Sender: TObject);
begin
    CreateShowModal(TAboutBox);
end;

procedure TFMainForm.sbButtonClick(Sender: TObject);
var
  st:Integer;
begin
   SelectedComponentName:=(Sender as TSpeedButton).Hint;
   st:=GetKeyState(VK_SHIFT);
   if SelectedComponentName = '' then ShiftKeyed:= False
   else if st < 0 then ShiftKeyed:= True
   else ShiftKeyed:= False;
end;

procedure TFMainForm.sbOpenFileClick(Sender: TObject);
begin
   OpenDialog1.Title:='Open';
   OpenDialog1.Filter := 'Delphi Files(*.pas;*.dpr)|*.pas;*.dpr'+
                         '|Delphi Project(*.dpr)|*.dpr'+
                         '|Delphi Unit(*.pas)|*.pas'+
                         '|Delphi Form(*.dfm)|*.dfm'+
                         '|Text File(*.txt)|*.txt'+
                         '|All Files (*.*)|*.*';
   OpenDialog1.InitialDir:= IniFile.ReadString('system', 'LastPath',FilePath);
   OpenDialog1.FilterIndex:= 1;
   if OpenDialog1.Execute then begin
      IniFile.WriteString('system', 'LastPath',ExtractFilePath(OpenDialog1.FileName));
      OpenFile(OpenDialog1.FileName);
   end;
end;

procedure TFMainForm.sbFormsClick(Sender: TObject);
var
   FormName:string;
begin
    // Ʈ Ե   ش.
    with TViewForm.Create(self) do begin
        Caption:='View Form';
        FileList.Items.Assign(ProjectInfo.FormItems);
        if ShowModal<>mrCancel then begin
           FormName:= GetUnitName(FileName.Text);
           OpenFile(FormName);
        end;
        Free;
    end;
end;

procedure TFMainForm.sbUnitsClick(Sender: TObject);
var
   I:Integer;
begin
    // Ʈ Ե Ʈ  ش.
    with TViewForm.Create(self) do begin
        Caption:='View Unit';
        FileList.Items.Clear;
        for I:= 0 to ProjectInfo.UnitItems.Count -  1 do
           FileList.Items.Add(GetNetFileName(ProjectInfo.UnitItems[I]));
        if ShowModal <> mrCancel then
           OpenFile(ProjectInfo.ProjectPath+FileName.Text+'.pas');
        Free;
    end;
end;

procedure TFMainForm.OpenFile(const FileName:string);
var
   Index:Integer;
   Ext:string;
begin
   if not FileExists(FileName) then  Exit;
   Ext:= ExtractFileExt(FileName);
   Index:= IsOpenedFile(FileName);  // ̹ ش   ִ ˻
   if Index <> -1 then begin
      EditorForm.PageControl1.ActivePage:= PageControl1.Pages[Index];
      Screen.Cursor:=crDefault;
      Exit;
   end;
   if Ext = '.dpr' then CreateSheet(FileName)
   //   쿡  ؽƮ ǥ о δ.
   else if Ext = '.dfm' then
       OpenFormAsText(FileName)
   else if Ext = '.pas' then begin
      CreateSheet(FileName);
      OpenForm(Copy(FileName,1,Length(FileName)-3)+'dfm');
   end
   else CreateSheet(FileName);
   SaveFileHistory(FileName);
end;

procedure TFMainForm.ViewProjectSourceItemClick(Sender: TObject);
var
   Index:Integer;
   FileName:string;
begin
   FileName:= ProjectInfo.ProjectName;
   Index:= IsOpenedFile(FileName);  // ̹ ش   ִ ˻
   if Index <> -1 then begin
      EditorForm.PageControl1.ActivePage:= PageControl1.Pages[Index];
      Screen.Cursor:=crDefault;
      Exit;
   end;
   CreateSheet(FileName);
end;

//  Ʈ  ҷ´.
procedure TFMainForm.sbOpenProjectClick(Sender: TObject);
begin
   OpenDialog1.Title:='Open Project';
 //  OpenDialog1.Filter := 'Project Files (*.dpr)|*.dpr|All Files (*.*)|*.*';
   OpenDialog1.FilterIndex:=2;
   OpenDialog1.InitialDir:= IniFile.ReadString('system', 'LastPath',FilePath);
   if OpenDialog1.Execute then  begin
      OpenProject(OpenDialog1.FileName);
      IniFile.WriteString('system', 'LastPath',ExtractFilePath(OpenDialog1.FileName));
   end;
end;

procedure TFMainForm.ViewProjectManagerItemClick(Sender: TObject);
begin
   with TProjectManager.Create(self) do begin
       GetProjectInfo;
       Show;
   end;
end;

procedure TFMainForm.ProjectCompileItemClick(Sender: TObject);
// Compile project
begin
  if IniFile.ReadBool('SYSTEM','DefaultCompiler',True) then
     CompileAndInformation('/M')
  else CompileAndInformation(IniFile.ReadString('Compiler','OtherOption', ''));
end;

procedure TFMainForm.ProjectBuildAllItemClick(Sender: TObject);
begin
   CompileAndInformation('/B');
end;

function ExecuteProcess(const ProcessName, Options, Parameter:string):Boolean;
// μ ϰ, μ   Ѵ.
var
   StartInfo:TStartupInfo;
   ProcessInfo:TProcessInformation;
   dwExitCode:DWord;
begin
  Result:=True;
  dwExitCode:= STILL_ACTIVE;
  FillChar(StartInfo, SizeOf(TStartupInfo), #0);
  FillChar(ProcessInfo, SizeOf(TProcessInformation), #0);
  StartInfo.cb := SizeOf(StartInfo);
  StartInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartInfo.wShowWindow:= SW_SHOW;
  CreateProcess( nil,
                 PChar(ProcessName + ' ' + Options + ' ' + Parameter),
                 nil,
                 nil,
                 False,
                 {CREATE_NEW_CONSOLE or} NORMAL_PRIORITY_CLASS,
                 nil,
                 nil,
                 StartInfo,
                 ProcessInfo );
  WaitForInputIdle(GetCurrentProcess(), INFINITE);
  if ProcessInfo.hProcess <> 0 then begin
     while (dwExitCode = STILL_ACTIVE) do begin
        WaitForSingleObject(ProcessInfo.hProcess,1000);
        GetExitCodeProcess(ProcessInfo.hProcess, dwExitCode);
     end;
  end;
end;

function TFMainForm.Compile(const ProjName, Option:string):Boolean;
// Compile active project (Option:compile option /B:Build All /M:Modified Only)
var
  S1,S2,BatchFile:string;
  List:TStringList;
  SaveResp:Integer;
  P:PChar;
// Check whether resource file exists or not
function CheckResourceFile: Boolean;
var
  ResName:string;
begin
   Result:= False;
   ResName:= ProjectInfo.ProjectName;
   ResName:= Format('%s.res',[ResName]);
   Result:= FileExists(ResName);
end;

procedure MakeResourceFile;
var
  ResName,Path:string;
begin
   ResName:= GetNetFileName(ProjectInfo.ProjectName);
   ResName:= Format('%s.res',[ResName]);
   Path:= ProjectInfo.ProjectPath;
   ResName:= AppendSlash(Path) + ResName;
   CopyFile(PChar(FilePath + 'default.res'), PChar(ResName), True);
end;

procedure MakeBatchFile;
var
  List:TStringList;
begin
   List:= TStringList.Create;
   List.Add(S1 + ' %1 %2');
   List.Add('PAUSE');
   List.SaveToFile(BatchFile);
   List.Free;
end;

begin
  Result:=True;
  BatchFile:= FilePath+'execute.bat';
  if not FileExists(CompilerName) then begin
     MsgDlg('Can not find complier! Check Compiler Path' + #10#13 + CompilerName,
             Application.Title, MB_OK);
     with TOptions.Create(self) do
     begin
         PageControl1.ActivePage:= PrefPage;
         ShowModal;
         Free;
     end;
     Result:= False;
     Exit;
  end;
  if (ProjectInfo.ProjectState = psChange) then begin
     SaveResp := MessageDlg(Format('Save Change to %s?',
              [ExtractFileName(ProjectInfo.ProjectName)]), mtWarning, mbYesNoCancel, 0);
     if SaveResp=idYes then SaveProject(ProjectInfo.ProjectName);
  end;
  if not CheckResourceFile then MakeResourceFile;
  Screen.Cursor:= crHourGlass;
  S1:= CompilerName;
  S2:= ProjName;
  SetLength(S1,Length(CompilerName));
  GetShortPathName(PChar(CompilerName),PChar(S1),Length(S1));
  SetLength(S2,Length(ProjName));
  GetShortPathName(PChar(ProjName),PChar(S2),Length(S2));
  {if not FileExists(BatchFile) then }MakeBatchFile;
  ExecuteProcess(BatchFile , Option ,S2);
  Screen.Cursor:= crDefault;
end;

function TFMainForm.CompileAndInformation(const Option:string):Boolean;
// Ʈ ϰ,   ش.
begin
   Compile(ProjectInfo.ProjectName, Option);
  //CreateShowModal(TCompile);
end;

procedure TFMainForm.RunRunItemClick(Sender: TObject);
// Ʈ ϰ, Ѵ.
var
   ret:integer;
   ExeName:string;
begin
   if Compile(ProjectInfo.ProjectName, '/M') then begin
      ExeName:=Copy(ProjectInfo.ProjectName,1,Length(ProjectInfo.ProjectName)-3)+'exe';
      ret:=WinExec(PChar(ExeName),SW_SHOWNORMAL);
      if ret<31 then MsgDlg('Cannot Execute ' + ExtractFileName(ExeName)+'!', Application.Title, MB_OK);
   end;
end;

procedure TFMainForm.SaveForm(Form:TForm;FormName:string);
// Form  Ѵ.
var
   Output: TMemoryStream;
   ResName:string;
   I:Integer;
begin
    Form.OnActivate:= nil;
    Form.OnCreate:= nil;
    Form.OnDestroy:= nil;
    Form.OnMouseDown:= nil;
    Form.OnMouseMove:= nil;
    Form.OnMouseUp:= nil;
    Form.OnResize:= nil;
    Form.OnPaint:= nil;
    for I:=Form.ComponentCount-1 downto 0 do begin
       if Form.Components[I] is TGrabHandle then  Form.Components[I].Free
       else if Form.Components[I].Name = 'ProxyPopupMenu1' then Form.Components[I].Free
       else if Form.Components[I] is TWrapperControl then  Form.Components[I].Free;
    end;
    ResName:= FormName;
    Output:=TMemoryStream.Create;
    OutPut.WriteComponentRes(ResName,Form);
    Output.SaveToFile(ResName);
    Output.Free;
    Form.Free;
    OpenForm(FormName);
end;

function TFMainForm.CreateForm(const FormName,UnitName:string):TForm;
// Ͻ  Ѵ.
begin
    Result:=CreateProxy(TProxyForm,'T'+GetNetFileName(FormName)) as TForm;
    with Result do begin
       BorderStyle:= bsSizeable;
       Caption:= GetNetFileName(FormName);
       Name:= GetNetFileName(FormName);
       TProxyForm(Result).FileName:= UnitName;
       ActiveUnit:= UnitName;
       OnPaint:=ProxyForm.FormPaint;
       Show;
       ActiveForm:=Result;
    end;
end;

procedure TFMainForm.CreateSheet(const FileName:string);
//  Ʈ  ִ ͸ Ѵ.
var
   PasEditor:TmwCustomEdit;
   TabSheet:TTabSheet;
   List:TStringList;
begin
   Inc(UnitCount);
   if UnitCount > 255 then
   begin
      ShowMessage('exceed maximum editor count(255)!');
      Exit;
   end;
   OpenUnitList[UnitCount].FileName:= FileName;
   TabSheet:=TTabSheet.Create(EditorForm.PageControl1);
   with TabSheet do
   begin
      PageControl := EditorForm.PageControl1;
      if ExtractFileExt(FileName)='.pas' then Caption:=GetNetFileName(FileName)
      else Caption:=ExtractFileName(FileName);
      PasEditor:=TmwCustomEdit.Create(EditorForm.PageControl1);
      PasEditor.Parent := TabSheet;
      PasEditor.Name := UniqueName(PasEditor);
      PasEditor.Color:= IniFile.ReadInteger('EDITOR','BackColor',clWhite);
      PasEditor.Font.Name:= IniFile.ReadString('EDITOR','FONTNAME','Courier New');
      PasEditor.Font.Size:= IniFile.ReadInteger('EDITOR','FONTSIZE',10);
      PasEditor.Align:=alClient;
      PasEditor.PopupMenu:=EditorForm.EditorLocalMenu;
      PasEditor.ScrollBars:=ssBoth;
      PasEditor.HighLighter:= EditorForm.mwPasSyn1;
      PasEditor.Tag:= UnitCount;
      PasEditor.OnKeyUp:=EditorForm.PasEditorKeyUp;
      if ExtractFileExt(FileName)='.dpr' then begin
      // ο Ʈ  ڵ带 
         PasEditor.Lines.Assign(ProjectInfo.ProjectSource);
      end
      else if not FileExists(FileName) then begin
      // ο Ʈ  ڵ带 
         List:=TStringList.Create;
         List:=CreateDefaultUnit(List,GetNetFileName(FileName),
               'Form'+FileName[Length(FileName)-4]);
         PasEditor.Lines.Assign(List);
         List.Free;
      end
      else if  ExtractFileExt(FileName)='.pas' then begin
         if IniFile.ReadBool('EDITOR','HighLight',True) then begin
            PasEditor.HighLighter:= EditorForm.mwPasSyn1;
            PasEditor.Lines.LoadFromFile(FileName);
         end
         else
         begin
            PasEditor.HighLighter:= nil;
            PasEditor.Lines.LoadFromFile(FileName);
         end;
         PasEditor.Modified:= False;
      end
      else  PasEditor.Lines.LoadFromFile(FileName);
      PasEditor.OnChange:=EditorForm.PasEditorChange;
   end;
   EditorForm.Caption:= ExtractFileName(FileName);
   EditorForm.PageControl1.ActivePage:=TabSheet;
   EditorForm.Show;
   ActivePasEditor:= PasEditor;
end;


procedure TFMainForm.CreateSheetAsStream(const FileName:string;Stream:TStream);
// ũ   ʰ , Stream   Ѵ.
var
   PasEditor:TmwCustomEdit;
   TabSheet:TTabSheet;
   List:TStringList;
begin
   TabSheet:=TTabSheet.Create(EditorForm.PageControl1);
   with TabSheet do
   begin
      PageControl := EditorForm.PageControl1;
      Caption:=ExtractFileName(FileName);
      PasEditor:=TmwCustomEdit.Create(EditorForm.PageControl1);
      PasEditor.Parent := TabSheet;
      PasEditor.Name := UniqueName(PasEditor);
      PasEditor.Color:= IniFile.ReadInteger('EDITOR','BackColor',clWhite);
      PasEditor.Font.Name:= IniFile.ReadString('EDITOR','FONTNAME','Arial');
      PasEditor.Font.Size:= IniFile.ReadInteger('EDITOR','FONTSIZE',10);
      PasEditor.Align:= alClient;
      PasEditor.PopupMenu:=EditorForm.EditorLocalMenu;
      PasEditor.ScrollBars:=ssBoth;
      PasEditor.HighLighter:= EditorForm.mwPasSyn1;
      PasEditor.OnKeyUp:=EditorForm.PasEditorKeyUp;
      if IniFile.ReadBool('EDITOR','HighLight',False) then begin
         PasEditor.HighLighter:= EditorForm.mwPasSyn1;
         PasEditor.Lines.LoadFromStream(Stream);
      end
      else
      begin
         PasEditor.HighLighter:= nil;
         PasEditor.Lines.LoadFromStream(Stream);
      end;
      PasEditor.Modified:= False;
      PasEditor.OnChange:=EditorForm.PasEditorChange;
   end;
   EditorForm.Caption:= ExtractFileName(FileName);
   EditorForm.PageControl1.ActivePage:=TabSheet;
   EditorForm.Show;
   ActivePasEditor:=PasEditor;
end;

procedure TFMainForm.sbMainMenuClick(Sender: TObject);
begin
   MsgDlg('Sorry! Not implement yet!', Application.Title, MB_OK);
end;

procedure TFMainForm.EditCopyItemClick(Sender: TObject);
begin
   if ActivePasEditor.SelText <> '' then begin
      ActivePasEditor.CopyToClipboard;
      EditorForm.Show;
   end
   else  ProxyDesigner.CopyComponent;
end;

procedure TFMainForm.EditPasteItemClick(Sender: TObject);
begin
   if not ClipBoard.HasFormat(CF_COMPONENT) then begin
      ActivePasEditor.PasteFromClipboard;
      EditorForm.Show;
   end
   else ProxyDesigner.PasteComponent;
end;

procedure TFMainForm.EditCutItemClick(Sender: TObject);
begin
   if ActivePasEditor.SelText <> '' then begin
    ActivePasEditor.CutToClipboard;
    EditorForm.Show;
   end
   else ProxyDesigner.CutComponent;
end;

procedure TFMainForm.FileSaveItemClick(Sender: TObject);
begin
   SaveFile(ActiveUnit);
end;

procedure TFMainForm.FilePrintItemClick(Sender: TObject);
begin
   CreateShowModal(TPrintSelDlg);
end;

procedure TFMainForm.EditSelectAllItemClick(Sender: TObject);
begin
   if ToggleFormUnit then begin
      if ProxyDesigner <> nil then  ProxyDesigner.SelectAll;
   end
   else begin
    ActivePasEditor.SelectAll;
    EditorForm.Show;
   end;
end;

procedure TFMainForm.EditUndoItemClick(Sender: TObject);
begin
    with ActivePasEditor do
       if HandleAllocated then SendMessage(Handle, EM_UNDO, 0, 0);
    EditorForm.Show;
end;

procedure TFMainForm.SearchGotoItemClick(Sender: TObject);
var
   ret:boolean;
   SLine:string;
   CurLine,NewLine:integer;
begin
    // Ư  ȣ ̵Ѵ.
    ret:=InputQuery('Go to Line Number','Enter New Line Number:!',SLine);
    if ret then begin
         ActivePasEditor.SetFocus;
         NewLine:=StrToIntDef(SLine,CurLine);
         ActivePasEditor.CaretY:= NewLine;
    end;
end;

procedure TFMainForm.ViewObjectInspectorItemClick(Sender: TObject);
begin
    ObjectInspector.Show;
end;

procedure TFMainForm.ViewNewEditorItemClick(Sender: TObject);
begin
    with EditorForm.Create(self) do Show;
end;

procedure TFMainForm.ViewSpeedBarItemClick(Sender: TObject);
begin
    SpeedBar.Visible:=not SpeedBar.Visible;
    ViewSpeedBarItem.Checked:=not ViewSpeedBarItem.Checked;
end;

procedure TFMainForm.ViewPaletteItemClick(Sender: TObject);
begin
   PageControl1.Visible:=not PageControl1.Visible;
   ViewPaletteItem.Checked:=not ViewPaletteItem.Checked;
end;

procedure TFMainForm.FileNewFormItemClick(Sender: TObject);
var
   UnitName:string;
   FormName:string;
begin
    with ProjectInfo do
    begin
       NewForm(FormName, UnitName);
       InsertProjectCode(ProjectPath+UnitName,ProjectPath+FormName);
       CreateSheet(ProjectPath+UnitName);
    end;
    CreateForm(GetNetFileName(FormName), UnitName);
    UpdateControl(psChange);
end;

procedure TFMainForm.SearchFindItemClick(Sender: TObject);
begin
    // ڿ ˻ ȭ鿡 ɼ Ѵ.
    with TSearch.Create(self) do begin
        if IniFile.ReadBool('EDITOR','FindTextCursor',True) then
           cbSearch.Text:= EditorForm.GetCursorWord;
        if ShowModal <> mrCancel then begin
           SearchText:= cbSearch.Text;
           if (chkWholeWord.Checked) then Include(SearchOption.FindOption,stWholeWord);
           if (chkMatchCase.Checked) then Include(SearchOption.FindOption,stMatchCase);
           if chkDown.Checked then SearchOption.Direction:= fdDown
           else SearchOption.Direction:= fdUp;
           if chkCursor.Checked then SearchOption.Origin:= foCursor
           else SearchOption.Origin:= foEntire;
           if chkEntire.Checked then SearchOption.Scope:= fsGlobal
           else SearchOption.Scope:= fsSelected;
           SearchingText(SearchText,SearchOption);
        end;
    end;
end;

procedure TFMainForm.FindDialog1Find(Sender: TObject);
var
   FindOption:TSearchTypes;
   LinePos:integer;
begin
    FindOption:=[];
    if Sender=FindDialog1 then begin
        SearchText:=(Sender as TFindDialog).FindText;
        if (frWholeWord in (Sender as TFindDialog).Options) then
           Include(FindOption,stWholeWord);
        if  (frMatchCase in (Sender as TFindDialog).Options) then
           Include(FindOption,stMatchCase);
    end;
   //// MatchPos:=ActivePasEditor.FindText(SearchText,EndPos,ActivePasEditor.GetTextlen,FindOption);
    if MatchPos<>-1 then begin
        EndPos:=MatchPos+Length(SearchText);
        SendMessage(ActivePasEditor.Handle,EM_SETSEL, MatchPos, EndPos);
        LinePos:=SendMessage(ActivePasEditor.Handle,EM_LINEFROMCHAR, -1,0);
        SendMessage(ActivePasEditor.Handle,EM_LINESCROLL, 0,LinePos-OldLine);
        OldLine:=LinePos;
        ActivePasEditor.SetFocus;
    end
    else begin
         MsgDlg('Search String Not Found!',Application.Title,mb_OK);
         EndPos:=0;
    end;
end;

procedure TFMainForm.SearchReplaceItemClick(Sender: TObject);
var
  CharRange:TCharRange;
  ReplaceText:string;
begin
    // ĳ ġ ִ ܾ Ѵ.
    SendMessage(ActivePasEditor.Handle, EM_EXGETSEL, 0, Longint(@CharRange));
    CharRange.cpMax:=SendMessage(ActivePasEditor.Handle, EM_FINDWORDBREAK,
                   WB_MOVEWORDRIGHT, CharRange.cpMin);
    SendMessage(ActivePasEditor.Handle, EM_EXSETSEL, 0, Longint(@CharRange));
    // ڿ ˻ ȭ鿡 ɼ Ѵ.
    with TReplace.Create(self) do begin
        cbSearch.Text:=Trim(ActivePasEditor.SelText);
        if ShowModal <> mrCancel then begin
           SearchText:= cbSearch.Text;
           ReplaceText:= cbReplace.Text;
           if (chkWholeWord.Checked) then Include(SearchOption.FindOption,stWholeWord);
           if (chkMatchCase.Checked) then Include(SearchOption.FindOption,stMatchCase);
           if chkDown.Checked then SearchOption.Direction:= fdDown
           else SearchOption.Direction:= fdUp;
           if chkCursor.Checked then SearchOption.Origin:= foCursor
           else SearchOption.Origin:= foEntire;
           if chkEntire.Checked then SearchOption.Scope:= fsGlobal
           else SearchOption.Scope:= fsSelected;
           SearchOption.ReplaceAll := ReplaceAll;
           SearchOption.PromptOn:= chkPrompt.Checked;
           ReplacingText(SearchText,ReplaceText,SearchOption);
        end;
    end;
end;

procedure TFMainForm.ReplaceDialog1Replace(Sender: TObject);
begin
   if (frReplaceAll in ReplaceDialog1.Options) then begin
       while MatchPos<>-1 do begin
           SendMessage(ActivePasEditor.Handle,EM_REPLACESEL, 0,Longint(PChar(ReplaceDialog1.ReplaceText)));
           FindDialog1Find(ReplaceDialog1);
       end;
   end
   else begin
       SendMessage(ActivePasEditor.Handle,EM_REPLACESEL, 0,Longint(PChar(ReplaceDialog1.ReplaceText)));
       FindDialog1Find(ReplaceDialog1);
   end;
end;

procedure TFMainForm.FileNewApplicationItemClick(Sender: TObject);
begin
   NewProject;
end;

procedure TFMainForm.FileCloseAllItemClick(Sender: TObject);
var
   I,SaveResp:Integer;
begin
    if (ProjectInfo.ProjectState= psChange) then begin
       SaveResp := MessageDlg(Format('Save Changes to project %s?',
              [ExtractFileName(ProjectInfo.ProjectName)]), mtWarning, mbYesNoCancel, 0);
        if  SaveResp=idYes then  SaveProject(ProjectInfo.ProjectName);
    end;
    //  Ʈ νƮ ϰ  ݴ´.
    for I:=0 to Screen.FormCount-1 do begin
        if (Screen.Forms[I] is TProxyForm) or (Screen.Forms[I] is TEditorForm)  then
           Screen.Forms[I].Close;
    end;
    //  Ϳ ⺻ TabSheet ϳ ܵΰ  Ѵ.
    with EditorForm.PageControl1 do
       for I:= PageCount - 1 downto 0 do
            Pages[I].Free;
    ProjectInfo.ProjectName:= '';
end;

function TFMainForm.OpenProject(const ProjName:string):Boolean;
// Open Delphi Project
var
  UnitName:string;
begin
    Result:= True;
    FileCloseAllItemClick(self);
    ProjectInfo.ProjectName:= ProjName;
    Caption:= Application.Title+' - '+ProjName;
    if FileExists(ProjName) then
    begin
       UnitName:= GetUnitName(ProjectInfo.MainForm);
       OpenFile(UnitName);
       SaveProjectHistory(ProjName);
    end
    else NewProject;
    UpdateControl(psOpen);
end;

function TFMainForm.SaveProject(const ProjName:string):Boolean;
// Ʈ Ѵ.
var
   I:Integer;
begin
    Result:= False;
    sbSaveAll.Enabled:=False;
    for I:=0 to ProjectInfo.UnitItems.Count-1 do begin
        ActiveUnit:= ProjectInfo.UnitItems[I];    // Ʈ ִ Ʈ ʷ Ѵ.
        SaveFile(ActiveUnit);
    end;
    if (ProjectInfo.ProjectState = psNew) or (not FileExists(ProjName)) then begin
       SaveDialog1.FileName:= ExtractFileName(ProjName);
       if SaveDialog1.Execute then begin
          ProjectInfo.ProjectName:= SaveDialog1.FileName;
          ProjectInfo.ProjectSource.SaveToFile(SaveDialog1.FileName);
       end;
    end
    else ProjectInfo.ProjectSource.SaveToFile(ProjName);
    ProjectInfo.ProjectState:= psSave;
    if ProjName<>'' then Result:=True;
    UpdateControl(psSave);
end;

procedure TFMainForm.sbSaveAllClick(Sender: TObject);
begin
   SaveProject(ProjectInfo.ProjectName);
end;

procedure TFMainForm.SaveFile(const FileName:string);
var
   SaveResp:integer;
   SaveName:string;
   LinkForm:TForm;
begin
    SaveName:= FileName;
    if FileName='Project1' then begin
       // ο Ʈ 
       SaveDialog1.FileName:='Project1.dpr';
       SaveDialog1.FilterIndex:=1;
       if SaveDialog1.Execute then  begin
          ProjectInfo.ProjectSource.SaveToFile(SaveDialog1.FileName);
          ProjectInfo.ProjectPath:=ExtractFilePath(SaveDialog1.FileName);
       end;
       Exit;
    end
    else if ExtractFileExt(FileName)='.pas' then begin
       LinkForm:= GetLinkForm;
       if LinkForm = nil then Exit;
       SaveName:= FileName;
       if not FileExists(FileName) then
       begin
         SaveDialog1.FileName:=FileName;
         SaveDialog1.FilterIndex:=2;
         if SaveDialog1.Execute then SaveName:=SaveDialog1.FileName;
       end;
       if SaveName <> '' then
          SaveForm(LinkForm,Copy(SaveName,1,Length(SaveName)-4)+'.dfm')
       else Exit;
    end;
    if (FileExists(SaveName)) and (FileName <> SaveName) then begin
       SaveResp := MessageDlg(Format('Same filename exists already!' +#10#13 +' Save changes to %s?',
                [ExtractFileName(SaveName)]), mtWarning, mbYesNoCancel, 0);
       case SaveResp of
            idYes:
               EditorForm.GetLinkEditor.Lines.SaveToFile(SaveName);
            idNo: Exit;
            idCancel: Abort;
       end;
    end
    else if FileName <> SaveName then begin
      EditorForm.RenameUnit(SaveName);
      EditorForm.GetLinkEditor.Lines.SaveToFile(SaveName);
      ProjectInfo.RenameUnit(ExtractFileName(FileName), ExtractFileName(SaveName));
    end
    else EditorForm.GetLinkEditor.Lines.SaveToFile(SaveName);
end;

procedure TFMainForm.sbToggleUnitClick(Sender: TObject);
//  Ʈ ϸ鼭 ȰȭѴ.
begin
   ToggleFormAndUnit;
end;

procedure TFMainForm.NHideClick(Sender: TObject);
begin
    SpeedBar.Visible:=False;
    ViewSpeedBarItem.Checked:=False;
end;

procedure TFMainForm.ToolsOptionsItemClick(Sender: TObject);
begin
    CreateShowModal(TOptions);
end;

procedure TFMainForm.ToolsImageEditItemClick(Sender: TObject);
var
   ret:integer;
begin
    Screen.Cursor:=crHourGlass;
    ret:=WinExec(PChar(CompilerPath+'IMAGEDIT.EXE'),SW_SHOWNORMAL);
    if ret<31 then MsgDlg('Cannot Execute Program !', Application.Title, MB_OK);
    Screen.Cursor:=crDefault;
end;

procedure TFMainForm.ToolsDatabaseItemClick(Sender: TObject);
var
   ret:integer;
begin
    Screen.Cursor:=crHourGlass;
    ret:=WinExec(PChar(DESKTOP+'DBD32.EXE'),SW_SHOWNORMAL);
    if ret<31 then MsgDlg('Cannot Execute Program!',Application.Title,MB_OK);
    Screen.Cursor:=crDefault;
end;

procedure TFMainForm.ProjectOptionsItemClick(Sender: TObject);
begin
    CreateShowModal(TProjOption);
end;

procedure TFMainForm.OpenForm(const FileName:string);
//   д´.
var
   Input,Output:TMemoryStream;
   Form:TForm;
   I:Integer;
procedure DeleteEventHandler;
var
  I:Integer;
begin
   for I:= SourceList.Count - 1 downto 0 do
      if Copy(Trim(SourceList[I]),1,2) = 'On' then
         SourceList.Delete(I);
end;

begin
    if not FileExists(FileName) then Exit;
    Form:= ReadDFM(FileName);
    if Form = nil then Exit;
    {$IFDEF VER100}
    Form.Designer:= TProxyDesigner.Create(Form);
    {$ENDIF}
    ProxyDesigner := TProxyDesigner(Form.Designer);
    if ProxyDesigner <> nil then ProxyDesigner.GetComponentList;
    ActiveUnit:= GetLinkUnit(FileName);
    TProxyForm(Form).FileName:= ActiveUnit;
    Form.Show;
    ActiveForm:=Form;
    // ۳Ʈ   ֵ ComponentState csDesigning Ѵ.
    for I:=0 to Form.ComponentCount - 1 do begin
       if Form.Components[I] is TWrapperControl then
          TWrapperControl(Form.Components[I]).UpdateControl;
       if not (Form.Components[I] is TControl) then
       begin
          if not (Form.Components[I] is TMenuItem) then
          ProxyDesigner.CreateComponent(TComponentClass(Form.Components[I].ClassType),
              ActiveForm, TControl(Form.Components[I]).Left,TControl(Form.Components[I]).Top,0,0);
       end;
       TExposeComponent(Form.Components[I]).SetDesigning(True);
    end;
   {
    Form:=CreateProxy(TProxyForm,GetNetFileName(FileName)) as TForm;
    Input:=TMemoryStream.Create;
    Input.LoadFromFile(FileName);
    Output:=TMemoryStream.Create;
    ObjectResourceToText(Input,Output);
    Output.Position:=0;
    SourceList.LoadFromStream(Output);

    //  ̺Ʈ ڵ鷯 ҴǾ ִ  EReadError  ߻ϱ
    //   б   ̺Ʈ ڵ鷯  , ̸
    //  Ϸ   о δ.
    DeleteEventHandler;
    SourceList.SaveToFile(FilePath+TempFile);
    Output.LoadFromFile(FilePath+TempFile);
    Output.SaveToFile(FilePath+TempFile);
    Output.Position:=0;
    Input.Clear;
    ObjectTextToResource(Output, Input);
    Input.SaveToFile(FilePath+TempForm);
    Input.LoadFromFile(FilePath+TempForm);

    Input.Position:=0;
    ReadClass;
    try
       Input.ReadComponentRes(Form);
    finally
       Input.Free;
       OutPut.Free;
       Form.Designer:= TProxyDesigner.Create(Form);
       ProxyDesigner := TProxyDesigner(Form.Designer);
       if ProxyDesigner <> nil then ProxyDesigner.GetComponentList;
       ActiveUnit:= FileName;
       TProxyForm(Form).FileName:= GetNetFileName(FileName)+'.pas';
       Form.Show;
       ActiveForm:=Form;
    end;
    // ۳Ʈ   ֵ ComponentState csDesigning Ѵ.
    for I:=0 to Form.ComponentCount - 1 do begin
       if Form.Components[I] is TWrapperControl then
          TWrapperControl(Form.Components[I]).UpdateControl;
       TExposeComponent(Form.Components[I]).SetDesigning(True);
    end;}
end;

procedure TFMainForm.OpenFormAsText(const FileName:string);
//   ؽƮ  д´.
var
   Input,Output:TMemoryStream;
begin
    if not FileExists(FileName) then Exit;
    Input:=TMemoryStream.Create;
    Input.LoadFromFile(FileName);
    Output:=TMemoryStream.Create;
    ObjectResourceToText(Input,Output);
    Output.Position:=0;
    Output.SaveToFile(FilePath+TempFile);
    CreateSheetAsStream(FileName , Output);
end;

procedure TFMainForm.NewProject;
begin
    FileCloseAllItemClick(self);
    with ProjectInfo do
    begin
        ProjectPath:= TempDir;
        ProjectName:= 'Project1.dpr';
    end;
    FileNewFormItemClick(self);
    ProjectInfo.ProjectState:= psNew;
    Caption:= Application.Title +  ' - Project1';
end;

function TFMainForm.GetSelectComponent:TComponentClass;
var
   SelectClass:TComponentClass;
begin
    SelectClass:= nil;
   // ReadClass;
    Result:= TComponentClass(GetClass(SelectedComponentName));
    if not ShiftKeyed then  SelectedComponentName:= '';
end;

function TFMainForm.GetLinkForm:TForm;
//  ϰ ִ Ʈ   ã´.
var
   I:Integer;
begin
   Result:= nil;
   for I:=0 to Screen.FormCount-1 do
   begin
      if Screen.Forms[I] is TProxyForm then
         if TProxyForm(Screen.Forms[I]).FileName = ActiveUnit then
         begin
            Result:=Screen.Forms[I];
            Break;
         end;
   end;
end;

procedure TFMainForm.ProxyFormShow(Sender: TObject);
begin
    if ProxyDesigner = nil then Exit;
    ObjectInspector.GetPropertyInfo(ProxyDesigner.Form);
    ProxyDesigner.GetComponentList;
    ObjectInspector.ComponentList.Text:= ProxyDesigner.Form.Name+':TForm';
end;

procedure TFMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
   SaveResp:Integer;
begin
    if (ProjectInfo.ProjectState = psChange) then begin
       SaveResp := MessageDlg(Format('Save Change to %s?',
              [ExtractFileName(ProjectInfo.ProjectName)]), mtWarning, mbYesNoCancel, 0);
        if  SaveResp=idYes then   SaveProject(ProjectInfo.ProjectName)
        else if SaveResp=idCancel then Action:= caNone;
    end;
    //SaveHistory(ProjectInfo.ProjectName);
end;

function TFmainForm.TryName(const Test:string;Comp:TComponent):Boolean;
{۳Ʈ ̸  ׽Ʈ غ,  ϴٸ True ϰ, ƴϸ
 False Ѵ.}
var
   I:Integer;
begin
    Result:=False;
    for I:=0 to Comp.ComponentCount-1 do
        if CompareText(Comp.Components[I].Name,Test) =0 then Exit;
    Result:=True;
end;

function TFMainForm.UniqueName(Comp:TComponent):string;
{ǥ  Ģ Ͽ ۳Ʈ   ̸ Ѵ.  <Ÿ><>
  ϴµ, <Ÿ> ۳Ʈ Ŭ ̸ 'T'  ̰, <>
 ̸ ϰ   ̴.}
var
   I:Integer;
   Fmt:string;
begin
    if Comp.ClassName[1] in ['t','T'] then
        Fmt:=Copy(Comp.ClassName,2,255)+'%d'
    else Fmt:=Comp.ClassName+'%d';
    if Comp.Owner=nil then begin
       {ڰ Ƿ  ̸ ϴ. 1 Ѵ.}
       Result:=Format(Fmt,[1]);
       Exit;
    end
    else begin
       { ̸   ,  ڸ  Ѵ.}
       for I:=1 to High(Integer) do begin
           Result:=Format(Fmt,[I]);
           if TryName(Result,Comp.Owner) then Exit;
       end;
    end;
end;

function TFMainForm.GetUnitName(const FormName:string):string;
// FormName  Ʈ ̸ Ѵ.
var
  I:Integer;
begin
    Result:='';
    for I:=0 to ProjectInfo.FormItems.Count-1 do begin
       if Pos(FormName,ProjectInfo.FormItems[I])>0 then begin
          Result:= ProjectInfo.UnitItems[I];
          Exit;
       end;
    end;
end;

procedure TFMainForm.ProjectAddItemClick(Sender: TObject);
begin
    OpenDialog1.FileName:='';
    OpenDialog1.FilterIndex:=3;
    if OpenDialog1.Execute then begin
       ProjectInfo.UnitItems.Add(GetNetFileName(OpenDialog1.FileName));
       ProjectInfo.FormItems.Add('Test');
       ProjectInfo.InsertProjectCode(GetNetFileName(OpenDialog1.FileName),'Test');
    end;
end;

procedure TFMainForm.ProjectRemoveItemClick(Sender: TObject);
begin
    CreateShowModal(TRemoveProject);
end;

procedure TFMainForm.SaveProjectHistory(const Project:string);
//  Ʈ ini History Ѵ.
var
   LastNum,I:Integer;
   List:TStringList;
begin
   List:=TStringList.Create;
   IniFile.ReadSectionValues('Closed Projects',List);
   for I:=0 to List.Count-1 do
       if List.Values[IntToStr(I)]=Project then begin
          List.Free;
          Exit;
       end;
   LastNum:=IniFile.ReadInteger('Closed Projects','Last',0);
   if LastNum < 5 then  begin
      IniFile.WriteInteger('Closed Projects','Last',LastNum+1);
      IniFile.WriteString('Closed Projects',IntToStr(LastNum+1),Project);
   end
   else  IniFile.WriteInteger('Closed Projects','Last',0);
end;

procedure TFMainForm.SaveFileHistory(const Filename:string);
var
   LastNum,I:Integer;
   List:TStringList;
begin
   List:=TStringList.Create;
   IniFile.ReadSectionValues('Closed Files',List);
   for I:=0 to List.Count-1 do
       if List.Values[IntToStr(I)]= Filename then begin
          List.Free;
          Exit;
       end;
   LastNum:=IniFile.ReadInteger('Closed Files','Last',0);
   if LastNum<15 then  begin
      IniFile.WriteInteger('Closed Files','Last',LastNum+1);
      IniFile.WriteString('Closed Files',IntToStr(LastNum+1),Filename);
   end
   else  IniFile.WriteInteger('ProjectHistory','Last',0);
end;

procedure TFMainForm.OpenHistory;
//  о Ʈ Ʈ ޴ ߰Ѵ.
var
   I:Integer;
   NewMenuItem:TMenuItem;
   List:TStringList;
begin
   List:=TStringList.Create;
   IniFile.ReadSectionValues('Closed Projects',List);
   for I:=0 to List.Count-1 do begin
      if FileExists(List.Values[IntToStr(I)]) then begin
         NewMenuItem:=TMenuItem.Create(Self);
         NewMenuItem.Caption:=List.Values[IntToStr(I)];
         NewMenuItem.OnClick:= OpenHistoryFile;
         FileReOpenItem.Add(NewMenuItem);
      end;
   end;
   NewMenuItem:=TMenuItem.Create(Self);
   NewMenuItem.Caption:= '-';
   NewMenuItem.OnClick:= nil;
   FileReOpenItem.Add(NewMenuItem);
   IniFile.ReadSectionValues('Closed Files',List);
   for I:=0 to List.Count-1 do begin
      if FileExists(List.Values[IntToStr(I)]) then begin
         NewMenuItem:=TMenuItem.Create(Self);
         NewMenuItem.Caption:=List.Values[IntToStr(I)];
         NewMenuItem.OnClick:= OpenHistoryFile;
         FileReOpenItem.Add(NewMenuItem);
      end;
   end;
   List.Free;
end;

procedure TFMainForm.OpenHistoryFile(Sender: TObject);
//  о Ʈ Ѵ.(ٽ  ޴ ϴ )
begin
   if ExtractFileExt((Sender as TMenuItem).Caption)='.dpr' then
      OpenProject((Sender as TMenuItem).Caption)
   else OpenFile((Sender as TMenuItem).Caption);
end;

procedure TFMainForm.ToggleFormAndUnit;
//  Ʈ ̸ ȯѴ.
var
  I:Integer;
  FileName:string;
begin
   if not ToggleFormUnit then begin
      for I:=0 to Screen.FormCount - 1 do
         if Screen.Forms[I] is TProxyForm then begin
            FileName:= ExtractFileName(TProxyForm(Screen.Forms[I]).FileName);
            if FileName  = EditorForm.Caption then
               Screen.Forms[I].SetFocus;
         end;
   end
   else EditorForm.SetFocus;
end;

procedure TFMainForm.ExecuteTool(Sender: TObject);
var
  ExeName:string;
begin
   ExeName:=IniFile.ReadString('Tools',(Sender as TMenuItem).Caption,'');
   WinExec(PChar(ExeName),SW_SHOWNORMAL);
end;

procedure TFMainForm.OpenTools;
var
   I:Integer;
   NewMenuItem:TMenuItem;
   List:TStringList;
begin
   List:=TStringList.Create;
   IniFile.ReadSection('Tools',List);
   for I:=0 to List.Count-1 do begin
         NewMenuItem:=TMenuItem.Create(Self);
         NewMenuItem.Caption:=List[I];
         NewMenuItem.OnClick:= ExecuteTool;
         ToolsMenu.Add(NewMenuItem);
   end;
   List.Free;
end;

procedure TFMainForm.ViewWindowListItemClick(Sender: TObject);
begin
    CreateShowModal(TWindowList);
end;

procedure TFMainForm.ViewComponentListItemClick(Sender: TObject);
begin
    CreateShowModal(TComponentList);
end;

procedure TFMainForm.ToolsToolsItemClick(Sender: TObject);
begin
   CreateShowModal(TTools);
end;

procedure TFMainForm.UpdateControl(State:TProjectState);
begin
    case State of
       psOpen:
       begin
           sbSaveAll.Enabled:= False;
           FileSaveAllItem.Enabled:= False;
       end;
       psSave:
       begin
           sbSaveAll.Enabled:= False;
           FileSaveAllItem.Enabled:= False;
       end;
       psChange:
       begin
           sbSaveAll.Enabled:= True;
           FileSaveAllItem.Enabled:= True;
       end;
       psNew:
       begin
           sbSaveAll.Enabled:= True;
           FileSaveAllItem.Enabled:= True;
       end;
    end;
end;

function TFMainForm.SearchingText(SearchStr:string;Options:TYB_SearchType):Boolean;
// ڿ ˻Ѵ.
var
   StartPos,TempPos,CaretPos:integer;
   CharRange:TCharRange;
begin
    Result:= True;
    StartPos:= SendMessage(ActivePasEditor.Handle, EM_LINEINDEX, -1,0);
   //// CaretPos:=ActivePasEditor.SelStart-StartPos+1;
    if Options.Direction = fdDown then
       StartPos:= StartPos+CaretPos+1
    else
       StartPos:= StartPos+CaretPos+1;
    if Options.Scope = fsSelected then begin  //   ˻ϴ 
       SendMessage(ActivePasEditor.Handle, EM_EXGETSEL, 0, Longint(@CharRange));
       CharRange.cpMax:=SendMessage(ActivePasEditor.Handle, EM_FINDWORDBREAK,
                     WB_MOVEWORDRIGHT, CharRange.cpMin);
       SendMessage(ActivePasEditor.Handle, EM_EXSETSEL, 0, Longint(@CharRange));
      //// MatchPos:=ActivePasEditor.FindText(SearchStr,CharRange.cpMin,CharRange.cpMax,Options.FindOption)
    end
    else if Options.Origin = foCursor then  // ĳ ġ ˻ ϴ 
       if Options.Direction = fdDown then   // Ʒ  ˻ϴ 
         //// MatchPos:=ActivePasEditor.FindText(SearchStr,StartPos,ActivePasEditor.GetTextLen,Options.FindOption)
       else begin
          TempPos:=0;
          while True do begin
           ////  TempPos:=ActivePasEditor.FindText(SearchStr,TempPos,StartPos,Options.FindOption);
             if TempPos <>-1 then MatchPos:= TempPos
             else Break;
             TempPos:= TempPos+2;
          end;
       end
    else
      //// MatchPos:=ActivePasEditor.FindText(SearchStr,0,ActivePasEditor.GetTextlen,Options.FindOption);
    if MatchPos<>-1 then begin // ڿ ˻  
        ActivePasEditor.SetFocus;
       //// ActivePasEditor.SelStart:=MatchPos;
       //// ActivePasEditor.SelLength := Length(SearchStr);
    end
    else begin
         MsgDlg('"'+SearchStr+'"'+' finished finding.',Application.Title,mb_OK);
         EndPos:=0;
         ActivePasEditor.SetFocus;
         Result:= False;
    end;
end;

procedure TFMainForm.SearchFindInFilesItemClick(Sender: TObject);
begin
   CreateShowModal(TFindInFile);
end;

procedure TFMainForm.ReplacingText(FindText,ReplaceText:string;Options:TYB_SearchType);
// ڿ ٸ ڿ ٲ۴.
var
  ret:Integer;
begin
   if (Options.ReplaceAll ) then begin //  ٲٱ⸦  
       while True do begin
           if not SearchingText(FindText,Options) then Exit;
           if (Options.PromptOn) and (ret<>mrAll) then begin  // ٲٱ Ȯ  ľ ϴ 
              ret:=MessageDlg('Replace '+FindText+'to '+ReplaceText+'?',
                      mtConfirmation,[mbYes,mbNo,mbCancel,mbAll],0);
              if (ret = mrYES) or (ret=mrAll) then
                 SendMessage(ActivePasEditor.Handle, EM_REPLACESEL, 0,Longint(PChar(ReplaceText)))
              else if ret = mrCancel then Exit;
           end
           else
              SendMessage(ActivePasEditor.Handle, EM_REPLACESEL, 0,Longint(PChar(ReplaceText)));
       end;
   end
   else if SearchingText(FindText,Options) then
      SendMessage(ActivePasEditor.Handle, EM_REPLACESEL, 0,Longint(PChar(ReplaceText)));
end;

procedure TFMainForm.ReadClass;
//  Ͽ ִ ۳Ʈ Ŭ Ѵ.
begin
    RegisterClasses([TForm,TButton,TMainMenu,TPopupMenu,TLabel,TEdit,TMemo,
                     TRadioButton,TCheckBox,TListBox,TComboBox,TScrollBar,
                     TGroupBox,TRadioGroup,TPanel,TBitBtn,TSpeedButton,TMaskEdit,
                     TStringGrid,TImage,TShape,TBevel,TScrollBox,TTabControl,
                     TPageControl,TTreeView,TListView,TImageList,THeaderControl,
                     TRichEdit,TStatusBar,TTrackBar,TProgressBar,TUpDown,THotKey,
                     {$IFDEF DBVERSION}
                     TTable,TQuery,TDataSource,TStoredProc,TDatabase,TSession,
                     TBatchMove,TUpdateSQL,TDBGrid,TDBNavigator,TDBText,TDBEdit,
                     TDBMemo,TDBImage,TDBListBox,TDBComboBox,TDBCheckBox,TDBRadioGroup,
                     TDBLookupListBox,TDBLookupComboBox,TDBCtrlGrid,
                     TDBRichedit,TDBLookupList,TDBLookupCombo,
                     {$ENDIF}
                     TTimer,
                     TPaintBox,TFileListBox,TDirectoryListBox,TDriveComboBox,
                     TFilterComboBox,TMediaPlayer,TGauge,TColorGrid,
                     TSpinButton,TSpinEdit,TDirectoryOutline,TCalendar,TWrapperControl,
                     TOpenDialog,TTabSheet,TSaveDialog,TFontDialog,TToolBar,TCoolBar,
                     TToolButton,TPrintDialog,TAnimate,TNotebook,TFindDialog,
                     TReplaceDialog,TOpenPictureDialog,TSavePictureDialog,
                     TPrinterSetupDialog,TColorDialog,TCheckListBox,TSplitter,
                     TStaticText,TDatetimePicker,TOleContainer,TDdeClientConv,
                     TDdeClientItem,TDdeServerConv,TDdeServerItem,
                     TTabSet,TOutline,
                     TTabbedNotebook, THeader
                     ]);
end;

procedure TFMainForm.FileSaveAs(FileName:string);
var
  SaveName:string;
  LinkForm:TForm;
  SaveResp:Integer;
begin
    SaveDialog1.InitialDir:= IniFile.ReadString('system', 'LastPath',FilePath);
    SaveDialog1.FileName:= FileName;
    SaveDialog1.FilterIndex:=2;
    if SaveDialog1.Execute then begin
       LinkForm:= GetLinkForm;
       SaveName:=SaveDialog1.FileName;
       if FileExists(SaveName) then begin
          SaveResp := MessageDlg(Format('Same filename exists already! Save changes to %s?',
               [ExtractFileName(SaveName)]), mtWarning, mbYesNoCancel, 0);
          case SaveResp of
             idYes:
                EditorForm.GetLinkEditor.Lines.SaveToFile(SaveName);
             idNo: Exit;
             idCancel: Abort;
          end;
       end
       else EditorForm.GetLinkEditor.Lines.SaveToFile(SaveName);
       SaveForm(LinkForm,Copy(SaveName,1,Length(SaveName)-4)+'.dfm');
    end;
end;

procedure TFMainForm.FileSaveAsItemClick(Sender: TObject);
begin
   FileSaveAs(EditorForm.Caption);
end;

procedure TFMainForm.FileSaveAllItemClick(Sender: TObject);
begin
   SaveProject(ProjectInfo.ProjectName);
end;

procedure TFMainForm.CloseActiveFile;
begin
   if TmwCustomEdit(EditorForm.PageControl1.ActivePage.Controls[0]).Modified then
      SaveFile(EditorForm.Caption);
   OpenUnitList[ActivePasEditor.Tag].Closed:= True;
   EditorForm.PageControl1.ActivePage.Free;
   EditorForm.PageControl1.SelectNextPage(True);
   ActiveForm.Free;
end;

procedure TFMainForm.FileCloseItemClick(Sender: TObject);
begin
   CloseActiveFile;
end;

procedure TFMainForm.EditFrontItemClick(Sender: TObject);
begin
   TProxyForm(ActiveForm).SelectControl.BringToFront;
end;

procedure TFMainForm.EditBackItemClick(Sender: TObject);
begin
   TProxyForm(ActiveForm).SelectControl.SendToBack;
end;

procedure TFMainForm.LoadLanguageRes;
// ڿ   ° Ѵ.
begin
   FileMenu.Caption                    := LoadStr(SFileMenu);
   FileNewItem.Caption                 := LoadStr(SFileNewItem);
   FileNewApplicationItem.Caption      := LoadStr(SFileApplicationItem);
   FileNewFormItem.Caption             := LoadStr(SFileNewFormItem);
   FileOpenItem.Caption                := LoadStr(SFileOpenItem);
   FileReopenItem.Caption              := LoadStr(SFileReopenItem);
   FileSaveItem.Caption                := LoadStr(SFileSaveItem);
   FileSaveAsItem.Caption              := LoadStr(SFileSaveAsItem);
   FileSaveProjectAsItem.Caption       := LoadStr(SFileSaveProjectAsItem);
   FileSaveAllItem.Caption             := LoadStr(SFileSaveAllItem);
   FileCloseItem.Caption               := LoadStr(SFileCloseItem);
   FileCloseAllItem.Caption            := LoadStr(SFileCloseAllItem);
   FileUseUnitItem.Caption             := LoadStr(SFileUseUintItem);
   FileAddItem.Caption                 := LoadStr(SFileAddItem);
   FileRemoveItem.Caption              := LoadStr(SFileRemoveItem);
   FilePrintItem.Caption               := LoadStr(SFilePrintItem);
   FileExitItem.Caption                := LoadStr(SFileExitItem);

   {EditMenu }
   EditMenu.Caption                    := LoadStr(SEditMenu);
   EditUndoItem.Caption                := LoadStr(SEditUndoItem);
   EditRedoItem.Caption                := LoadStr(SEditRedoItem);
   EditCutItem.Caption                 := LoadStr(SEditCutItem);
   EditCopyItem.Caption                := LoadStr(SEditCopyItem);
   EditPasteItem.Caption               := LoadStr(SEditPasteItem);
   EditDeleteItem.Caption              := LoadStr(SEditDeleteItem);
   EditSelectAllItem.Caption           := LoadStr(SEditSelectAllItem);
   EditAlignGridItem.Caption           := LoadStr(SEditAlignGridItem);
   EditFrontItem.Caption               := LoadStr(SEditFrontItem);
   EditBackItem.Caption                := LoadStr(SEditBackItem);
   EditAlignItem.Caption               := LoadStr(SEditAlignItem);
   EditSizeItem.Caption                := LoadStr(SEditSizeItem);
   EditScaleItem.Caption               := LoadStr(SEditScaleItem);
   EditTabOrderItem.Caption            := LoadStr(SEditTabOrderItem);
   EditCreateOrderItem.Caption         := LoadStr(SEditCreateOrderItem);

   {SearchMenu}
   SearchMenu.Caption                  := LoadStr(SSearchMenu);
   SearchFindItem.Caption              := LoadStr(SSearchFindItem);
   SearchFindinfilesItem.Caption       := LoadStr(SSearchFindinfilesItem);
   SearchReplaceItem.Caption           := LoadStr(SSearchReplaceItem);
   SearchAgainItem.Caption             := LoadStr(SSearchSearchAgainItem);
   SearchIncrementalItem.Caption       := LoadStr(SSearchIncrementalItem);
   SearchGotoItem.Caption              := LoadStr(SSearchGotoLineItem);
   SearchBrowseSymbolItem.Caption      := LoadStr(SSearchBrowseSymbolItem);

   {View Menu}
   ViewMenu.Caption                    := LoadStr(SViewMenu);
   ViewProjectManagerItem.Caption      := LoadStr(SViewProjectManagerItem);
   ViewProjectSourceItem.Caption       := LoadStr(SViewProjectSourceItem);
   ViewObjectInspectorItem.Caption     := LoadStr(SViewObjectInspectorItem);
   ViewAlignItem.Caption               := LoadStr(SViewAlignItem);
   ViewBrowseItem.Caption              := LoadStr(SViewBrowseItem);
   ViewComponentListItem.Caption       := LoadStr(SViewComponentListItem);
   ViewWindowListItem.Caption          := LoadStr(SViewWindowListItem);
   ViewToggleFormItem.Caption          := LoadStr(SViewToggleFormItem);
   ViewUnitItem.Caption                := LoadStr(SViewUnitItem);
   ViewFormItem.Caption                := LoadStr(SViewFormItem);
   ViewNewEditorItem.Caption           := LoadStr(SViewNewEditorItem);
   ViewSpeedBarItem.Caption            := LoadStr(SViewSpeedBarItem);
   ViewPaletteItem.Caption             := LoadStr(SViewPaletteItem);

   {Project Menu}
   ProjectMenu.Caption                 := LoadStr(SProjectMenu);
   ProjectAddItem.Caption              := LoadStr(SProjectAddItem);
   ProjectRemoveItem.Caption           := LoadStr(SProjectRemoveItem);
   ProjectAddRepositoryItem.Caption    := LoadStr(SProjectAddRepositoryItem);
   ProjectCompileItem.Caption          := LoadStr(SProjectCompileItem);
   ProjectBuildAllItem.Caption         := LoadStr(SProjectBuildAllItem);
   ProjectSyntaxItem.Caption           := LoadStr(SProjectSyntaxItem);
   ProjectInformationItem.Caption      := LoadStr(SProjectInformationItem);
   ProjectOptionsItem.Caption          := LoadStr(SProjectOptionsItem);

   {Run Menu}
   RunMenu.Caption                     := LoadStr(SRunMenu);
   RunRunItem.Caption                  := LoadStr(SRunRunItem);
   RunParametersItem.Caption           := LoadStr(SRunParametesItem);
   RunStepOverItem.Caption             := LoadStr(SRunStepOverItem);
   RunTraceIntoItem.Caption            := LoadStr(SRunTraceIntoItem);
   RunRuntoCursorItem.Caption          := LoadStr(SRunRuntoCursorItem);
   RunProgramPauseItem.Caption         := LoadStr(SRunProgramPauseItem);
   RunProgramResetItem.Caption         := LoadStr(SRunProgramResetItem);
   RunAddWatchItem.Caption             := LoadStr(SRunAddWatchItem);
   RunAddBreakpointItem.Caption        := LoadStr(SRunAddBreakpointItem);
   RunEvaluateItem.Caption             := LoadStr(SRunEvaluateItem);

   {Component Menu}
   ComponentMenu.Caption               := LoadStr(SComponentMenu);
   ComponentNewComponentItem.Caption   := LoadStr(SComponentNewComponent);
   ComponentInstallComponent.Caption   := LoadStr(SComponentInstallComponent);
   ComponentInstallPackages.Caption    := LoadStr(SComponentInstallPackages);
   ComponentConfigurePalette.Caption   := LoadStr(SComponentConfigurePalette);

   {Database Menu}
   DatabaseMenu.Caption                := LoadStr(SDatabaseMenu);
   DatabaseExploreItem.Caption         := LoadStr(SDatabaseExploreItem);
   DatabaseFormWizardItem.Caption      := LoadStr(SDatabaseFormWizardItem);

   {Tools Menu}
   ToolsMenu.Caption                   := LoadStr(SToolsMenu);
   ToolsOptionsItem.Caption            := LoadStr(SToolsOptionsItem);
   ToolsGalleryItem.Caption            := LoadStr(SToolsGalleryItem);
   ToolsToolsItem.Caption              := LoadStr(SToolsToolsItem);
   ToolsImageEditItem.Caption          := LoadStr(SToolsImageEditItem);
   ToolsDatabaseItem.Caption           := LoadStr(SToolsDatabaseItem);

   HelpMenu.Caption                    := LoadStr(SHelpMenu);
   HelpContextItem.Caption             := LoadStr(SHelpContextItem);
   HelpAboutItem.Caption               := LoadStr(SHelpAboutItem);

   sbOpenProject.Hint                  := LoadStr(SsbOpenProjectHint);
   sbSaveAll.Hint                      := LoadStr(SsbSaveAllHint);
   sbAddProject.Hint                   := LoadStr(SsbAddProjectHint);
   sbUnits.Hint                        := LoadStr(SsbUnitsHint);
   sbForms.Hint                        := LoadStr(SsbFormsHint);
   sbRun.Hint                          := LoadStr(SsbRunHint);
   sbPause.Hint                        := LoadStr(SsbPauseHint);
   sbOpenFile.Hint                     := LoadStr(SsbOpenFileHint);
   sbSave.Hint                         := LoadStr(SsbSaveHint);
   sbRemoveProject.Hint                := LoadStr(SsbRemoveProjectHint);
   sbToggleUnit.Hint                   := LoadStr(SsbToggleUnitHint);
   sbNewForm.Hint                      := LoadStr(SsbNewFormHint);
   sbTraceInto.Hint                    := LoadStr(SsbTraceIntoHint);
   sbStepOver.Hint                     := LoadStr(SsbStepOverHint);     
end;

procedure TFMainForm.EditAlignItemClick(Sender: TObject);
var
  AlignDialog:TAlignDialog;
begin
   AlignDialog:= TAlignDialog.Create(self);
   AlignDialog.ShowModal;
   AlignDialog.Free;
end;

procedure TFMainForm.EditSizeItemClick(Sender: TObject);
var
  SizeDialog:TSizeDialog;
begin
   SizeDialog:= TSizeDialog.Create(self);
   SizeDialog.ShowModal;
   SizeDialog.Free;
end;

procedure TFMainForm.HelpContextItemClick(Sender: TObject);
begin
   Application.HelpCommand(HELP_FINDER, 0);
end;

procedure TFMainForm.EditScaleItemClick(Sender: TObject);
var
  ScaleForm:TScaleForm;
begin
   ScaleForm:= TScaleForm.Create(self);
   ScaleForm.ShowModal;
   ScaleForm.Free;
end;

procedure TFMainForm.FormDestroy(Sender: TObject);
begin
   if FileExists(FilePath + TempFile) then DeleteFile(FilePath + TempFile);
   if FileExists(FilePath + TempForm) then DeleteFile(FilePath + TempForm);
end;

procedure TFMainForm.FileSaveProjectAsItemClick(Sender: TObject);
begin
   SaveProject(TempProject);
end;

procedure TFMainForm.MakeBitmap(Component:TSpeedButton;ComponentName:string);
// Make bitmap of component
var
  ResName: array[0..64] of Char;
  ResBitmap: TBitmap;
begin
  ResBitmap := TBitmap.Create;
  try
    StrPLCopy(ResName, ComponentName, SizeOf(ResName));
    AnsiUpper(ResName);
    ResBitmap.Handle := LoadBitmap(hInstance, ResName);
    if ResBitmap.Handle = 0 then
      ResBitmap.Handle := LoadBitmap(hInstance, 'DEFAULT');

    Component.Glyph:= ResBitmap;
  finally
    ResBitmap.Free;
  end;
end;

procedure TFMainForm.LoadDefaultButton(TabSheet:TTabSheet);
// Load default button
var
  Button:TSpeedButton;
procedure CreateButton(ButtonName:string;Index:Integer);
begin
   Button:=TSpeedButton.Create(TabSheet);
   with Button do begin
      Name := UniqueName(Button);
      if Index = 0 then Down:= True;
      Flat:= True;
      GroupIndex:= 1;
      Height:= 28;
      Left:= Index * 29;
      Parent := TabSheet;
      Top:= 5;
      Width:= 28;
      OnClick:= sbButtonClick;
   end;
   MakeBitmap(Button,ButtonName);
end;
begin
   CreateButton('CURSOR',0);
end;

procedure TFMainForm.CreatePalettePage(PalettePage:string);
// Create component of palette page (page name is PalettePage)
var
  TabSheet:TTabSheet;
  Button:TSpeedButton;
  ComponentNames, ComponentName:string;
  Temp, Pos1, Index:Integer;
procedure CreateButton(ButtonName:string);
begin
   Button:=TSpeedButton.Create(TabSheet);
   with Button do begin
      Name := UniqueName(Button);
      Flat:= True;
      GroupIndex:= 1;
      Height:= 28;
      Hint:= ButtonName;
      Left:= Index * 29;
      Parent := TabSheet;
      ShowHint:= True;
      Top:= 5;
      Width:= 28;
      OnClick:= sbButtonClick;
   end;
   MakeBitmap(Button,ButtonName);
end;
begin
   TabSheet:=TTabSheet.Create(self);
   with TabSheet do
   begin
      PageControl := PageControl1;
      Caption:= PalettePage;
      Name := UniqueName(TabSheet);
   end;
   LoadDefaultButton(TabSheet);
   ComponentNames:= IniFile.ReadString('Palette',PalettePage, '');
   if ComponentNames = '' then Exit;
   Pos1:= 0;
   Temp:= 1;
   Index:= 1;
   while True do begin
      Pos1:= NPos(';', ComponentNames, Temp, Length(ComponentNames));
      if Pos1 = 0 then Break;
      ComponentName:= Copy(ComponentNames, Temp, Pos1 - Temp -1);
      CreateButton(ComponentName);
      Temp:= Pos1;
      Inc(Index);
   end;
end;

procedure TFMainForm.LoadDefaultPalette();
// Load default palette when palette not exists
begin
   with IniFile do begin
      WriteString('Palette', 'Standard' ,'TMainMenu;TPopupMenu;TLabel;TEdit;TMemo;TButton;TCheckBox;TRadioButton;TListBox;TComboBox;TScrollBar;TGroupBox;TRadioGroup;TPanel;');
      WriteString('Palette', 'Addtional' ,'TBitBtn;TSpeedButton;TMaskEdit;TStringGrid;TDrawGrid;TImage;TShape;TBevel;TScrollBox;TCheckListBox;TSplitter;TStaticText;');
      WriteString('Palette', 'Win32' ,'TTabControl;TPageControl;TImageList;TRichEdit;TTrackBar;TProgressBar;TUpDown;THotKey;TAnimate;TDateTimePicker;TTreeView;TListView;THeaderControl;TStatusBar;TToolBar;TCoolBar;');
      WriteString('Palette', 'System' ,'TTimer;TPaintBox;TMediaPlayer;TOleContainer;TDdeClientConv;TDdeClientItem;TDdeServerConv;TDdeServerItem;');
     // WriteString('Palette', 'Internet' ,'TClientSocket;TServerSocket;TWebDispatcher;TPageProducer;TQueryTableProducer;TDataSetTableProducer;TFTP;THTML;THTTP;TNNTP;TPOP;TSMTP;TTCP;TUDP;');
     {$IFDEF DBVERSION}
      WriteString('Palette', 'Data Access' ,'TDataSource;TTable;TQuery;TStoredProc;TDatabase;TSession;TBatchMove;TUpdateSQL');
      WriteString('Palette', 'Data Controls' ,'TDBGrid;TDBNavigator;TDBText;TDBEdit;TDBMemo;TDBImage;TDBListBox;TDBComboBox;TDBCheckBox;TDBRadioGroup;TDBLookupListBox;TDBLookupComboBox;TDBRichEdit;TDBCtrlGrid;TDBChart;');
      WriteString('Palette', 'QReport' ,'TQuickRep;TQRSubDetail;TQRBand;TQRChildBand;TQRGroup;TQRLabel;TQRDBText;TQRExpr;TQRSysData;TQRMemo;TQRRichText;TQRDBRichText;TQRShape;TQRImage;TQRDBImage;TQRCompositeReport;TQRPreview;TQRChart;');
      {$ENDIF}
      WriteString('Palette', 'Dialogs' ,'TOpenDialog;TSaveDialog;TOpenPictureDialog;TSavePictureDialog;TFontDialog;TColorDialog;TPrintDialog;TPrinterSetupDialog;TFindDialog;TReplaceDialog;');
      WriteString('Palette', 'Win 3.1' ,'TDBLookupList;TDBLookupCombo;TTabSet;TOutline;TTabbedNotebook;TNotebook;THeader;TFileListBox;TDirectoryListBox;TDriveComboBox;TFilterComboBox;');
      WriteString('Palette', 'Samples' ,'TGauge;TColorGrid;TSpinButton;TSpinEdit;TCalendar');
   end;
end;

procedure TFMainForm.LoadingComponents;
// Dynamic loading components
var
  PaletteList:TStringList;
  I:Integer;
  PalettePage:string;
begin
   PaletteList:= TStringList.Create;
   ReadClass;
   IniFile.ReadSectionValues('Palette',PaletteList);
   if PaletteList.Count <= 0 then begin
      LoadDefaultPalette;
      IniFile.ReadSectionValues('Palette',PaletteList);
   end;
   for I:=0 to PaletteList.Count - 1 do begin
      PalettePage:= PaletteList.Names[I];
      if PalettePage <> '' then CreatePalettePage(PalettePage);
   end;
end;

procedure TFMainForm.ComponentNewComponentItemClick(Sender: TObject);
begin
   CreateShowModal(TNewComponent);
end;

procedure TFMainForm.ViewAlignItemClick(Sender: TObject);
begin
   CreateShowModal(TAlignPalette);
end;

procedure TFMainForm.Breakpoints1Click(Sender: TObject);
begin
   CreateShowModal(TBPWindowForm);
end;

procedure TFMainForm.ViewBrowseItemClick(Sender: TObject);
begin
   CreateShowModal(TBrowserForm);
end;

procedure TFMainForm.EditCreateOrderItemClick(Sender: TObject);
begin
   CreateShowModal(TCreationOrderDlg);
end;

procedure TFMainForm.RunEvaluateItemClick(Sender: TObject);
begin
   CreateShowModal(TEvalDialog);
end;

procedure TFMainForm.FileNewItemClick(Sender: TObject);
begin
   CreateShowModal(TGalleryBrowseDlg);
end;

procedure TFMainForm.Modules1Click(Sender: TObject);
begin
   CreateShowModal(TModulesView);
end;

procedure TFMainForm.ToolsGalleryItemClick(Sender: TObject);
begin
   CreateShowModal(TRepositConfigDlg);
end;

procedure TFMainForm.RunParametersItemClick(Sender: TObject);
begin
   CreateShowModal(TRunParamsDlg);
end;

procedure TFMainForm.EditTabOrderItemClick(Sender: TObject);
begin
   CreateShowModal(TTabOrderDlg);
end;

procedure TFMainForm.RunAddWatchItemClick(Sender: TObject);
begin
   CreateShowModal(TWatchEditDlg);
end;

procedure TFMainForm.ComponentConfigurePaletteClick(Sender: TObject);
var
  Options:TOptions;
begin
   Options:= TOptions.Create(self);
   with Options do begin
      PrefPage.Free;
      CompilerPage.Free;
      EditorPage.Free;
      EdDispPage.Free;
      EdColorPage.Free;
      BrowPage.Free;
      CodeInsight.Free;
      PageControl1.ActivePage:= PalPage;
      GetPalette;
      ShowModal;
      Free;
   end;
end;

procedure TFMainForm.FileNewDataModuleItemClick(Sender: TObject);
begin
   FileNewDataModuleClick;
end;

procedure TFMainForm.FileNewDataModuleClick;
begin

end;

procedure TFMainForm.FileUseUnitItemClick(Sender: TObject);
begin
   FileUseUnit;
end;

procedure TFMainForm.FileUseUnit;
begin

end;

procedure TFMainForm.EditRedoItemClick(Sender: TObject);
begin
   EditRedo;
end;

procedure TFMainForm.EditRedo;
begin

end;

procedure TFMainForm.EditDeleteItemClick(Sender: TObject);
begin
   EditDelete;
end;

procedure TFMainForm.EditDelete;
begin

end;

procedure TFMainForm.EditAlignGridItemClick(Sender: TObject);
begin
   EditAlignToGrid;
end;

procedure TFMainForm.EditAlignToGrid;
begin

end;

procedure TFMainForm.SearchIncrementalItemClick(Sender: TObject);
begin
   SearchIncrementalClick;
end;

procedure TFMainForm.SearchIncrementalClick;
begin

end;

procedure TFMainForm.SearchBrowseSymbolItemClick(Sender: TObject);
begin
   SearchSymbol;
end;

procedure TFMainForm.SearchSymbol;
begin

end;

procedure TFMainForm.ProjectAddRepositoryItemClick(Sender: TObject);
begin
   ProjectAddRepository;
end;

procedure TFMainForm.ProjectAddRepository;
begin

end;

procedure TFMainForm.ProjectSyntaxItemClick(Sender: TObject);
begin
   ProjectSyntaxCheck;
end;

procedure TFMainForm.ProjectSyntaxCheck;
begin

end;

procedure TFMainForm.ProjectInformationItemClick(Sender: TObject);
begin
   ProjectInformation;
end;

procedure TFMainForm.ProjectInformation;
begin

end;

procedure TFMainForm.RunStepoverItemClick(Sender: TObject);
begin
   RunStepOver;
end;

procedure TFMainForm.RunStepOver;
begin

end;

procedure TFMainForm.RunTraceintoItemClick(Sender: TObject);
begin
   RunStepInto;
end;

procedure TFMainForm.RunStepInto;
begin

end;

procedure TFMainForm.RunRuntocursorItemClick(Sender: TObject);
begin
   RunGotoCursor;
end;

procedure TFMainForm.RunGotoCursor;
begin

end;

procedure TFMainForm.RunProgramPauseItemClick(Sender: TObject);
begin
   RunPause;
end;

procedure TFMainForm.RunPause;
begin

end;

procedure TFMainForm.RunProgramResetItemClick(Sender: TObject);
begin
   ProgramReset;
end;

procedure TFMainForm.ProgramReset;
begin

end;

procedure TFMainForm.RunAddBreakpointItemClick(Sender: TObject);
begin
   RunAddBreakpoint;
end;

procedure TFMainForm.RunAddBreakpoint;
begin

end;

procedure TFMainForm.ComponentInstallComponentClick(Sender: TObject);
begin
   AddtoPackage1Click;
end;

procedure TFMainForm.AddtoPackage1Click;
begin
   CreateShowModal(TInstallComponent);
end;

procedure TFMainForm.ComponentInstallPackagesClick(Sender: TObject);
begin
   InstallPackagesClick;
end;

procedure TFMainForm.InstallPackagesClick;
var
  ProjOption: TProjOption;
begin
   ProjOption:= TProjOption.Create(self);
   with ProjOption do begin
      FormsPage.Free;
      ApplicationPage.Free;
      CompilerPage.Free;
      LinkerPage.Free;
      DirCondPage.Free;
      VersionInfo.Free;
      PageControl1.ActivePage:= PakListSheet;
      LoadKnownPackages;
      ShowModal;
      Free;
   end;
end;

procedure TFMainForm.Configure2Click(Sender: TObject);
begin
   ComponentConfigurePaletteClick(self);
end;

procedure TFMainForm.Hide2Click(Sender: TObject);
// Hide Component Palette
begin
   Hide2.Checked:= not Hide2.Checked;
   PageControl1.Visible:= not Hide2.Checked;
   ViewPaletteItem.Checked:= not Hide2.Checked;
end;

procedure TFMainForm.ProcessShowHint(var HintStr: string; var CanShow: Boolean;
            var HintInfo: THintInfo);
begin
   if HintInfo.HintControl = nil then Exit;
   if (HintInfo.HintControl).Parent = SpeedBar then
      CanShow:= ShowSpeedbarHint.Checked
   else if  ((HintInfo.HintControl).Parent).ClassName = 'TTabSheet' then
      CanShow:= ShowPaletteHints.Checked;
end;

procedure TFMainForm.ShowSpeedbarHintClick(Sender: TObject);
begin
   ShowSpeedbarHint.Checked:= not ShowSpeedbarHint.Checked;
end;

procedure TFMainForm.ShowPaletteHintsClick(Sender: TObject);
begin
   ShowPaletteHints.Checked:= not ShowPaletteHints.Checked;
end;

procedure TFMainForm.SpeedbarHelpItemClick(Sender: TObject);
// Show Speedbar Help
var
  KeyWord:string;
begin
   KeyWord:= 'SpeedBar command';
   Application.HelpCommand(HELP_KEY,longint(KeyWord));
end;

procedure TFMainForm.PaletteHelpItemClick(Sender: TObject);
// Show Component Palette Help
var
  KeyWord:string;
begin
   KeyWord:= 'Component Palette command';
   Application.HelpCommand(HELP_KEY,longint(KeyWord));
end;

procedure TFMainForm.Configure1Click(Sender: TObject);
begin
   CreateShowModal(TSpeedbarEditor);
end;

procedure TFMainForm.HandelHelp1Click(Sender: TObject);
begin
  ShellExecute(self.Handle,nil, PChar(FilePath+'handel.hlp'),
               nil, nil, SW_SHOWNORMAL);
end;

procedure TFMainForm.Compileactivefile1Click(Sender: TObject);
begin
   Compile(ActiveUnit, '/M');
end;

function TFMainForm.GetLinkUnit(FormName:string):string;
//  unit ش.
var
   I:Integer;
begin
   Result:= '';
   if FormName = '' then Exit;
   I:= Pos('.', FormName);
   if I > 0 then Result:= Copy(FormName, 1, I) + 'pas'
   else Result:= FormName + '.pas';
end;

function TFMainForm.IsOpenedFile(const FileName:string):Integer;
// FileName ̹  ִ ؼ   ش ε ش.
var
   I:Integer;
begin
   Result:=-1;
   if FileName = '' then Exit;
   for I:=Low(OpenUnitList) to High(OpenUnitList) do
      if (OpenUnitList[I].FileName = FileName) and (not OpenUnitList[I].Closed) then begin
         Result:= I;
         Exit;
      end;
end;

end.


