unit UMenuitem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, DsgnIntf, TypInfo;

type
  TMenuItemForm = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    tvMenuItem: TTreeView;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    ComboBox1: TComboBox;
    edCaption: TEdit;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    Edit6: TEdit;
    ComboBox7: TComboBox;
    btnOK: TButton;
    btnCancel: TButton;
    btnInsert: TButton;
    btnDelete: TButton;
    btnSubmenu: TButton;
    PopupMenu1: TPopupMenu;
    iNSERT1: TMenuItem;
    Delete1: TMenuItem;
    N1: TMenuItem;
    CreateSubmenu1: TMenuItem;
    MainMenu1: TMainMenu;
    procedure btnInsertClick(Sender: TObject);
    procedure btnSubmenuClick(Sender: TObject);
    procedure edCaptionKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnDeleteClick(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure iNSERT1Click(Sender: TObject);
    procedure CreateSubmenu1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FMenuItems:TMenuItem;
    FDesigner: TFormDesigner;
    procedure SetMenuItems(Value:TMenuItem);
    procedure AddMenuClass(const S:string);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; Designer: TFormDesigner);
    property MenuItems:TMenuItem read FMenuItems write SetMenuItems;
  end;

var
  MenuItemForm: TMenuItemForm;

implementation

{$R *.DFM}


constructor TMenuItemForm.Create(AOwner: TComponent; Designer: TFormDesigner);
begin
   FDesigner:= Designer;
   inherited Create(AOwner);
end;

procedure TMenuItemForm.AddMenuClass(const S:string);
begin
   tvMenuItem.Items.AddChild(nil, S);
end;

procedure TMenuItemForm.btnInsertClick(Sender: TObject);
begin
    tvMenuItem.Items.AddChild(nil, 'MenuItem');
end;

procedure TMenuItemForm.btnSubmenuClick(Sender: TObject);
var
   Node:TTreeNode;
begin
    if tvMenuItem.Selected = nil then Exit;
    Node:= tvMenuItem.Items.AddChild(tvMenuItem.Selected, 'SubMenuItem');
    if Node <> nil then tvMenuItem.Selected:= Node;
    tvMenuItem.SetFocus;
end;

procedure TMenuItemForm.edCaptionKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if Key = VK_RETURN then
   begin
      if tvMenuItem.Selected = nil then Exit;
      tvMenuItem.Selected.Text:= edCaption.Text;
   end;
end;

procedure TMenuItemForm.btnDeleteClick(Sender: TObject);
begin
    if tvMenuItem.Selected = nil then Exit;
    tvMenuItem.Items.Delete(tvMenuItem.Selected);
    tvMenuItem.SetFocus;
end;

procedure TMenuItemForm.Delete1Click(Sender: TObject);
begin
   btnDeleteClick(self);
end;

procedure TMenuItemForm.iNSERT1Click(Sender: TObject);
begin
    btnInsertClick(self);
end;

procedure TMenuItemForm.CreateSubmenu1Click(Sender: TObject);
begin
    btnSubmenuClick(self);
end;

procedure TMenuItemForm.SetMenuItems(Value:TMenuItem);
begin
end;

procedure TMenuItemForm.FormCreate(Sender: TObject);
begin
   tvMenuItem.Items.Clear;
   if FDesigner <> nil then
      FDesigner.GetComponentNames(GetTypeData(TypeInfo(TMenuItem)), AddMenuClass);
end;

end.
